;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;asar JUMP patch
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;hex edits
;feather
;timeup
;tide
;bill
;scroll
;flame
;piranha
;fire-berry
;horizontal scroll
;NMSTL
;overworld counters
;extended level names + overworld counters(DC)
;sram expand (DC)
;all yoshi coins (disabled)
;disable score
;jump clip fix
;wall jump, note block fix
;ycoinfix + dc counter
;owspeed
;spikeswimfix
;double spinjump antifail + relative y spd
;no cape rng (disabled)
;pitfix (disabled)
;7E0071_fix
;overworld menu
;custom hud
;enable save prompt flag fix
;booforducking
;bonus star -> coin
;interaction_fast
;extradisco
;extra message
;coin sfx (floating coins only)
;extra translevel
;initram
;powerup init
;entrance edit
;yoshi init fix
;sprite extention recover
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

lorom
header

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;hex edits
	
	org $02895f	;directional coin block can be hit mutiple times
		db $80

	org $048e2e	;BGM will play after defeating Reznor, etc
		db $80

	org $009e25	;Lives at the start are set to 25
		db $18

	org $02cafa	;fixes chuck arm palette
		db $4b,$0b

	org $02fdb8	;fixes bat ceiling gfx
		db $ae,$ae,$c0,$e8

	org $0291f4	;fixes bounce tile of side-bouncing turnblock
		db $40

	org $01e2fb	;monty mole delay same on YI submap as elsewhere
		db $20

	org $04eb42	;FoI paths reveal at same rate as other maps'
		db $80

	org $00913f	;x133F, fixes the "S" in "Mario/Luigi Start"
		db $34

	org $009170	;x1370, fixes the "S" in "Mario/Luigi Start"
		db $f4

	org $009d30	;x1F30, title screen "Erase Game" palette darken fix
		db $ea,$ea,$ea,$ea,$ea

	org $00a439	;x2639, fixes the Koopa Paratroopa wing glitch
		db $80

	org $00cba3	;x4DA3, fixes a misplaced tile on the keyhole "iris in" effect
		db $49

	org $03cfaf	;x1D1AF, fixes Wendy's bow
		db $08

	org $03cfb5	;x1D1B5, fixes Wendy's bow
		db $08

	org $03d1d7	;x1D3D7, fixes Wendy's bow
		db $1f,$1e

	org $03d1dd	;x1D3DD, fixes Wendy's bow
		db $1e,$1f

	org $00f878	;revert
		db $d0

	org $05da1d	;no yoshi translevel
		db $FF
	
	org $04dbf1	;Luigi & AMK
		db $ea,$ea

	org $0096C7	;title screen music
		db $3C

	org $048DDA	;Sunken Ghost Ship glitch
		db $80

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;feather
	org $01c5ae
		lda.b #$03
		sta.b $71
		lda.b #$18
		sta.w $1496
		lda.b $81
		sta.b $7f
		bne   $2e
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;timeup
	org $008e21
		autoclean jml TickTime
	org $008e4f
		bne TimeIsntZero
	org $008e60
		lda.w $0f32
		ora.w $0f33
		bne TimeIsntZero
		lda.b #$ff
		nop
		autoclean jsl TimeUp
	TimeIsntZero:
	org $00d0e6
		autoclean jsl CheckIfTimeUpMsg
		nop	

	freecode
	TickTime:
		lda.w $0d9b
		cmp.b #$c1
		beq .DontTick
		lda.w $0f30
		bmi .DontTick
		jml $008e28
	.DontTick
		jml $008e6f
	
	TimeUp:
		sta.w $0f30
		jml $00f606
	
	CheckIfTimeUpMsg:
		ldy.b #$0b
		lda.w $0f31
		ldx.w $0f30
		bmi .DoTimeUp
		inc a
	.DoTimeUp
		rtl

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;tide
	org $019162
		autoclean jml Tidefix1
	org $019183
		autoclean jml Tidefix2
	
	freecode
	Tidefix1:
		adc.b $26
		ldy.w $1403
		bne .dont
		sta.b $e4,x
		jml   $819166
	.dont
		jml   $81916e
	
	Tidefix2:
		sbc.b $26
		ldy.w $1403
		bne .dont
		sta.b $e4,x
		jml $819187
	.dont
		jml $81918f

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;bill
	org $05d923
		autoclean jsl BillFixSub
		nop
	org $0184e3
		autoclean jsl BillFix
		rts
	
	freecode
	BillFixSub:
		lda.b #$01
		sta.w $1411
		lda.w $1413
		bne .return
		rep #$20
		stz.w $1466
		stz.b $1e
		sep #$20
	.return
		rtl

	BillFix:
		lda.b #$10
		sta.w $1540,x
		lda.b #$09
		sta.w $1dfc
		rtl

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;scroll
	org $80f700
		autoclean jml scrollfix

	freecode
	scrollfix:
		lda.w $1468
		sta.w $20
		sep #$20
		LDA $13BF
		CMP #$70	; color a dinosaur
		BNE +
		REP #$20
		JML $80F705
	+
		lda.b $5b
		lsr
		bcc .horzlevel
	.vertlevel
		rep #$20
		lda.l $7f8321
		cmp.w $1464
		sep #$20
		lda.b #$00
		bcs $02
		lda.b #$02
		sta.b $56
		rep #$20
		jml $80f75c
	.horzlevel
		rep #$20
		lda.l $7f831f
		cmp.w $1462
		sep #$20
		lda.b #$00
		bcs $02
		lda.b #$02
		sta.b $55
		rep #$20
		lda.l $7f8323
		cmp.w $1466
		sep #$20
		lda.b #$00
		bcs $02
		lda.b #$02
		sta.b $56
		rep #$20
		jml $80f70d

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;flame
	org $02df6e
		nop

	org $02f9cf
		autoclean jml loadY
	
	freecode
	loadY:
		lda.w $185e
		lsr a
		tay
		lda $1e02,x
		jml $82f9d6

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;piranha
	org $00d26a
		autoclean jsl PIR
		nop #2

	org $018e8d
		autoclean jsl PIRAHNA
		bra NoNop
		nop
		nop
		nop
		nop
		NoNop:

	freecode	
	PIRAHNA:
		lda.b $9e,x
		cmp.b #$1a
		beq .IsClassic
		lda.w $030b,y
		and.b #$f1
		ora.b #$0b
		sta.w $030b,y
		rtl
	.IsClassic
		lda.w $0307,y
		and.b #$f1
		ora.b #$0b
		sta.w $0307,y
		rtl

	PIR:
		stz.w $13f9
		stz.w $1419
		lda.w $1497
		bne .NoNew
		inc $1497
	.NoNew
		rtl
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;fire-berry
	org $00c4f8
		autoclean jml fireberryfix
		nop
		
	freecode
	fireberryfix:
		lda.b $71
		beq +
		stz.w $13fb
		+
		lda.w $13fb
		beq +
		jml $00c58f
		+
		jml $00c500

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;horizontal scroll
	org $009708
		autoclean jsl Mymain
	
	freecode
	Mymain:
		lda.b [$65]
		and.b #$1f
		inc a
		sta.b $5e
		rtl

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;NMSTL

	!foundSlot = PickOAMSlot_foundSlot
	
	macro speedup(offset)
		lda.w $02fd+<offset>	; get Y position of PREVIOUS tile in OAM
		cmp.b #$f0		; F0 means it's free (Y=F0 means it can't be seen)
		beq ?notFound		; \  if last isn't free
		lda.b #<offset>		;  | (and this is), then
		jmp !foundSlot		; /  this is the index
	?notFound:
	endmacro

	macro bulkSpeedup(arg)
		%speedup(<arg>+12)
		%speedup(<arg>+8)
		%speedup(<arg>+4)
		%speedup(<arg>)
	endmacro


	org $0180D2
	SpriteOAMHook:            
		bra .cutToTheChase	; skip the nop's
		nop			; \
		nop			;  | use nop
		nop			;  | to take
		nop			;  | up space
		nop			;  | to overwrite
		nop			;  | old code
		nop			;  |
		nop			;  |
		nop			;  |
		nop			;  |
		nop			;  |
		nop			;  |
		nop			; /
	.cutToTheChase	
		autoclean jsl PickOAMSlot		; jsl to new code

	freecode
	PickOAMSlot:
		lda.w $1692		; \  if sprite header
		cmp.b #$10		;  | setting is not 10,
		bne .default		; /  use the old code
	.notLastSpr	
		lda.w $14c8,x		; \ it's not necessary to get an index
		beq .return		; / if this sprite doesn't exist
		lda.b $9e,x		; \  give yoshi
		cmp.b #$35		;  | the first
		beq .yoshi		; /  two tiles
		jmp SearchAlgorithm	; search for a slot
	.foundSlot	
		sta.w $15ea,x		; set the index
	.return
		rtl			
	.yoshi		
		lda.b #$28		; \ Yoshi always gets
		sta.w $15ea,x		; / first 2 tiles (28,2C)
		rtl
	.default	
		phx			; \
		txa			;  | for when not using
		ldx.w $1692		;  | custom OAM pointer
		clc			;  | routine, this is
		adc.l $07f0b4,x		;  | the original SMW
		tax			;  | code.
		lda.l $07f000,x		;  |
		plx			;  |
		sta.w $15ea,x		; /
		rtl
    
	SearchAlgorithm:
		%bulkSpeedup($F0)	; \
		%bulkSpeedup($E0)	;  | pre-defined
		%bulkSpeedup($D0)	;  | macros with
		%bulkSpeedup($B0)	;  | code for each
		%bulkSpeedup($A0)	;  | individual
		%bulkSpeedup($90)	;  | slot check
		%bulkSpeedup($80)	;  |
		%bulkSpeedup($70)	;  |
		%bulkSpeedup($60)	;  |
		%bulkSpeedup($50)	;  |
		%bulkSpeedup($40)	;  |
		%speedup($3C)		;  |
		%speedup($38)		;  |
		%speedup($34)		; /
		lda.w $18e2		; \ Yoshi?
		bne .yoshiExists	; /
		%speedup($30)		; \ More slot
		%speedup($2C)		; / checks
		lda.b #$28		; \ if none of the above yield which slot
		jmp !foundSlot		; / then use the slot at the beginning
		
	.yoshiExists	
		lda.b #$30		; \ if none of the above yield which slot,
		jmp !foundSlot		; / then use the slot at the beginning (after Yoshi)
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;overworld counters
	
	org $008222
		autoclean jsl OWYICOIN
		nop
	
	freecode
	OWYICOIN:
		; recover
		LDA $13D9
		CMP #$0A
		RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;extended level names + overworld counters(DC)

	table table.txt

	org $03bb22
		autoclean jml TransConv
	org $03bb30
		asl
	org $03bb37
		autoclean jml levelNameHack

	freecode
	TransConv:
		STA $02
		SEP #$20
		LDA.l $7FC800,x
		BEQ +
		LDA $02
		AND #$1F
		CLC
		ADC #$60
		STA $02
	+
		REP #$20
		LDA $02
		ASL
		ASL
		ASL
		ASL
		JML $83BB26

	levelNameHack:
		tax

		LDA $02
		PHA

		lda.w $837b
		tay
		clc
		adc.w #$0026
		sta.b $02
		clc
		adc.w #$0004
		clc
		adc.w #$0026
		sta.b $00
		clc
		ADC #$0006	; adc.w #$0004
		sta.w $837b
		lda.w #$2500
		sta.w $837f,y
		lda.w #$6b50
		sta.w $837d,y
		sep #$20
		-   jsr .letter1
		cpy.b $02
		bcc -
		rep #$20
		LDA #$2700	; lda.w #$2500
		sta.w $8383,y
		lda.w #$8b50
		sta.w $8381,y
		iny
		iny
		iny
		iny
		sep #$20
		-   jsr .letter1
		cpy.b $00
		bcc -

		; OWYoshiCoin
		REP #$20
		SEP #$10
		PLA
		STA $02
		SEP #$20
		PHB
		PHK
		PLB
		LDX.b #.endtable-.table-1
		LDA $02
	-
		CMP .table,x
		BEQ +
		DEX
		BPL -
	+
		PLB
		CPX #$00
		BMI .y
	.n
		REP #$30
		LDA #$28FF
		STA $8381,y
		BRA .cnt
	.y
		PHY
		LDA $02
		LSR #3
		TAX
		LDA $02
		AND #$07
		TAY
		CPX #$0C
		BCC ++
		LDA.l $7FA4A0-$C,x
		BRA +++
	++
		LDA.l $7E1F2F,x
	+++
		TYX
		PLY
		AND.l $05B35B,x
		REP #$30
		BEQ +
		LDA #$288E
		STA $8381,y
		BRA .cnt
	+
		LDA #$3978
		STA $8381,y
	.cnt
		; dc counter
		LDA #$6353
		STA $8383,y
		LDA #$0700
		STA $8385,y
		LDA #$288E
		STA $8387,y
		LDA #$388F
		STA $8389,y
		SEP #$20
		LDA #$39
		STA $838C,y
		STA $838E,y
		SEP #$10
		LDA.l $7E13C5
		LDX #$00
	-
		CMP #$0A
		BCC +
		SBC #$0A
		INX
		BRA -
	+
		REP #$10
		CLC
		ADC #$22
		STA $838D,y
		SEP #$10
		TXA
		REP #$10
		BEQ +
		CLC
		ADC #$22
		BRA ++
	+
		LDA #$1F
	++
		STA $838B,y
		REP #$20
		TYA
		CLC
		ADC #$000E
		TAY
		SEP #$20
		jml $03bb69

	.letter1
		lda.l NameData,x
		sta.w $8381,y
		lda.b #$39
		sta.w $8382,y
		iny
		iny
		inx
		rts
	.table
		incsrc DCdata.asm
	.endtable


	NameData:
		incsrc LevelNameData.asm


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;sram expand (DC)

	!SRAMSize = #$02

	macro LoadIfStarted()
		LDA $8A
		PHA
		; vanilla
		SEP #$30
		PHB

		LDX $010A
		LDA #$00
		PHA
		PLB
		PHK
		PEA .pos-1
		PEA $84CE
		JML $809DB5
	.pos
		PLB
		REP #$30
		LDX $8A
		PLA
		STA $8A
		CPX #$5A5A
		BNE INITSRAM
	endmacro

	org $00FFD8
		db !SRAMSize	

	org $009BC9
		autoclean JML SaveGame

	org $009E5C
		autoclean JML LoadGame

	org $009B3F
		autoclean JML EraseGame

	freecode
	SAVETable:					;Amount of bytes to save : Address to save : SRAM address to save to
		dw $000C : dl $7E1F2F : dl $700400		;dragon coins table
		dw $0001 : dl $7E13C5 : dl $70040C		;dragon coin counter
		dw $0024 : dl $7FA480 : dl $70040D		;extra translevel
		dw $0000	; End
	INC:
		dw $0000 : dw $0400 : dw $0800		;Amount of bytes to increase by when using a different file (1-3)
	BINC:
		db $00 : db $00 : db $00			;Amount of bytes to increase by when using a different file (1-3)

	macro GetReady()
		LDA SAVETable+2,x	;\ Get RAM address
		STA $00			;/
		LDA SAVETable+5,x	;\
		CLC			; | Get SRAM address
		ADC $0B			; |
		STA $03			;/
		SEP #$20		;
		LDA SAVETable+4,x	;\ Get bank byte for RAM
		STA $02			;/
		LDA SAVETable+7,x	;\
		CLC			; | Get the bank byte for SRAM
		ADC $0D			; |
		STA $05			;/
		REP #$20		;
		LDY #$0000		; Y = #$0000
	endmacro

	SaveGame:
		PHK			;\ Set DBR
		PLB			;/
		LDY $010A		; Get game file 
		LDA BINC,y		;\ Get bank byte to increase by
		STA $0D			;/
		TYA			;\
		ASL A			; | Y*2
		TAY			;/
		REP #$30		; A, X, Y = 16-bit
		LDA INC,y		;\ Read low and high byte to increase by
		STA $0B			;/
		LDX #$0000		; X = #$0000
	.setup
		LDA SAVETable,x		;\ Get amount of bytes to write
		BEQ .end		;/
		STA $0E			; Store to scratch RAM
	%GetReady()
	.loop
		SEP #$20		;
		LDA [$00],y		; Load RAM
		STA [$03],y		; Store to SRAM
		REP #$20		;
		INY			; Y+1
		DEC $0E			; Check if we wrote to all SRAM
		BNE .loop		; Back if we haven't
		TXA			; X->A
		CLC			;\
		ADC #$0008		;/
		TAX			; A->X
		BRA .setup		; Back we go

	.end
		SEP #$30		;
		PHB			;\
		PHA			; | Set DBR
		PLB			;/
		LDX $010A		; Get game file
		JML $809BCF		;


	LoadGame:
		STZ $0DD5		;\ Restore old code
		STZ $0DB3		;/
		PHB			;
		PHK			;
		PLB			;
		LDY $010A		; Get game file 
		LDA BINC,y		; Get bank byte to increase by
		STA $0D			;
		TYA			;\
		ASL A			; | Y*2
		TAY			;/
		REP #$30		; A, X, Y = 16-bit
		LDA INC,y		;\ Read low and high byte to increase by
		STA $0B			;/
	%LoadIfStarted()
		LDX #$0000
	.setup
		LDA SAVETable,x
		BEQ .end
		STA $0E
	%GetReady()
	.loop
		SEP #$20
		LDA [$03],y
		STA [$00],y
		REP #$20
		INY
		DEC $0E
		BNE .loop
		TXA
		CLC
		ADC #$0008
		TAX
		BRA .setup

	.end
	EndLoad:
		SEP #$30
		PLB
		JML $809E62


	EraseGame:
		BEQ +
		JML $809B6D           

	INITSRAM_BIT:		; FIXED
		db $04,$02,$01
	INITSRAM:
		SEP #$30
		LDX $010A
		LDA.l INITSRAM_BIT,x
		BRA INITIT

		+
		PHB			;\
		PHK			; | Set DBR
		PLB			;/
		LDA $0DDE		;\ If we don't want to erase any file, don't even waste time
		BEQ EndIt		;/
	INITIT:				;
		STA $0D			; Store the files we want to erase in $0D
		REP #$10		;
	Redo:				;
		SEP #$20		;
		LDY #$0002		;\
		LDX #$0000		; |
		LDA $0D			; |
		BEQ EndIt		; |
		AND #$01		; |
		BNE Clear		; |
		DEY			; | Erase the correct SRAM addr.
		LDA $0D			; |
		AND #$02		; |
		BNE Clear		; |
		DEY			; |
		LDA $0D			; |
		AND #$04		; |
		BNE Clear		;/
	EndIt:
		SEP #$20		;
		LDA $0DDE		;\
		CMP #$0F		; | If this is not the erase game mode, branch
		BEQ EndLoad		;/
		PLB			;
		SEP #$10		;
		LDY #$02		; Old code
		JML $809B43  		; Return

	Clear:
		TRB $0D
		LDA SAVETable+7,x	;\
		CLC			; | Get the bank byte for SRAM
		ADC BINC,y		; |
		STA $05			;/
		REP #$20		; A, X, Y = 16-bit
		LDA SAVETable,x		;\ 
		BEQ Redo		; | Read size
		STA $0E			;/
		PHY			; FIXED
		TYA			;\
		AND #$00FF		; |
		ASL A			; | Y*2
		TAY			;/
		LDA SAVETable+5,x	;\
		CLC			; | Get SRAM address
		ADC INC,y		; |
		STA $03			;/
		LDY #$0000		; Y = #$0000
	.loop
		SEP #$20		;
		LDA #$00		;\ Write zero to SRAM
		STA [$03],y		;/
		REP #$20		;
		INY			; Y+1
		DEC $0E			;\ Loop until we wrote everything
		BNE .loop		;/
		TXA			;\
		CLC			; |
		ADC #$0008		; | Get the next table entry
		TAX			; |
		PLY			; FIXED
		SEP #$20		;/
		BRA Clear+2		;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;all yoshi coins (disabled)

	ORG $008FD8			;handles drawing of yoshi-coins in status bar
		autoclean JML YoshiCode   ;Jump to my code
	freecode
	YoshiCode:
		LDA $1422
		CMP #$05
		JML $808FDD

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;disable score

	org $028758;turn blocks
		BRA +
	org $028773
	+

	org $02AE12;score sprites
		BRA +
	org $02AE35
	+

	org $05CEF2;level end
		BRA +
	org $05CF05
	+

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;jump clip fix

	org $01AA37					;\JSL $xxxxxx takes 4 bytes
		autoclean JML JumpClipFix_Restore	;/
		BPL +
		LDA #$A8
	+
		STA $7D

	freecode

	JumpClipFix_Restore:
		LDA #$D0
		BIT $15
		JML $81AA3B

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;wall jump, note block fix

	org $00E9F6				;\ Hijack code and JSL to custom code
		autoclean JSL SideScreen	;/ this hijack runs when Mario is against the side of the screen
		NOP

	org $00EA16				;\ NOP out the anti-clipping routine here
		BRA Skip1			;| 
		NOP #10				;|
		Skip1:				;/

	org $00EBD9				;\ reset old hex edit which didn't really fix the note block death glitch
		db $02				;/

	org $00EC7E				;\ Hijack code and JSL to custom code
		autoclean JSL Block		;| this hijack runs when Mario is against a block
		NOP				;/

	org $00ED1C
		autoclean JSL BigMarioStuckInOneBlockHighSpace
		NOP #4

	freecode
	Block:
		CMP #$11       ;\ fix note block clipping glitch by changing the blocked bits
		BNE Skip6      ;| to be set depending on Mario's direction
		PHX            ;| 
		LDX $7B        ;|
		BPL Skip7      ;|
		LDA #$12       ;|
		Skip7:         ;|
		PLX            ;|
		Skip6:         ;/
		TSB $77        ;\ restore old code
		AND.b #$03     ;|
		TAY            ;/
		LDA $00        ;\ Use $00 as temporary freeRAM, restoring its value at the end
		PHA            ;/
		LDA $96        ;\ Don't move Mario outside the block instantly if his head is in the block
		AND #$F0       ;|
		STA $00        ;|
		LDA $98        ;|
		AND #$F0       ;|
		CMP $00        ;|
		BNE Skip2      ;|
		JSR NoClipping ;|
		BRA Skip3      ;|
		Skip2:         ;/
		PHX            ;\ Put blocked bits into X to select side of block to move Mario to
		LDA $77        ;|
		AND #$03       ;|
		LSR A          ;|
		TAX            ;/
		LDA $1933      ;\ If layer 1 interaction is being processed, Mario is being crushed horizontally
		CMP #$00       ;| between layer 1 and layer 2, and the layer 1 block is on the right, set X to 00
		BNE Skip5      ;| to avoid a glitch where Mario clips in and out of the block really fast before dying
		LDA $77        ;|
		AND #$03       ;|
		CMP #$03       ;|
		BNE Skip5      ;|
		CPY #$01       ;|
		BNE Skip5      ;|
		LDX #$00       ;|
		Skip5:         ;/
		LDA $94        ;\ Move Mario outside the block instantly
		AND #$F0       ;|
		ORA.l $00E911,x;|
		STA $94        ;|
		PLX            ;/
		Skip3:
		PLA
		STA $00
		RTL

	SideScreen:
		PHX
		TYX
		LDA.l $00E90A,x;\ restore old code
		TSB $77        ;/
		PLX
		JSR NoClipping
		RTL

	BigMarioStuckInOneBlockHighSpace:
		LDA $77        ;\ If blocked from the right, do nothing
		AND #$01       ;| If not blocked from the left, subtract 1 from Mario's x position
		BNE Skip4      ;| If blocked from the left, subtract 2 from Mario's x position
		REP #$20       ;|
		DEC $94        ;| 
		SEP #$20       ;|
		LDA $77        ;|
		AND #$02       ;|
		BEQ Skip4      ;|
		REP #$20       ;|
		DEC $94        ;|
		SEP #$20       ;/
		Skip4:
		LDA $77        ;\ restore old code
		AND.b #$FC     ;|
		ORA.b #$09     ;|
		STA $77        ;/
		RTL

	NoClipping:
		LDA $77        ;\ anti-clipping routine moved here
		AND #$03       ;|
		BEQ Return     ;|
		AND #$02       ;|
		PHX            ;|
		TAX            ;|
		REP #$20       ;|
		LDA $94        ;|
		CLC            ;|
		ADC.l $00E90D,x;| ADC.l doesn't work with y, so this uses x
		STA $94        ;|
		SEP #$20       ;|
		PLX            ;/
		Return:
		RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ycoinfix + dc counter

	org $00f31b
		nop #3

	org $00F332
		CPY #$2D
		BCC $31
		PHY
		JSL $00F377
		INC $1422
		LDA $1422
		CMP #$05
		BCC $0B
		PHX
		JSR $F3B2
		autoclean jsl adddccounter
		nop #2
		PLX
		LDA #$1C
		STA $1DF9
		LDA #$01
		JSL $05B330
		LDA #$01
		STA $9C
		JSL $00BEB0
		autoclean JML NewGen

	freecode
	reset bytes

	adddccounter:
		TYX
		CPX #$0C
		BCC +
		ORA $7FA4A0-$C,x
		STA $7FA4A0-$C,x
		BRA ++
	+
		ora.w $1f2f,x
		sta.w $1f2f,x
	++
		lda.w $1422
		cmp.b #05
		BNE +

		STZ $13C5
		LDX #$0B
	-
		LDA $1F2F,x
		JSR .checkbyte
		DEX
		BPL -
		
		LDX #$03
	-
		LDA $7FA4A0,x
		JSR .checkbyte
		DEX
		BPL -
	+
		RTL
	.checkbyte
		CMP #$80
		BCC +
		INC $13C5
		AND #$7F
	+
		CMP #$40
		BCC +
		INC $13C5
		AND #$3F
	+
		CMP #$20
		BCC +
		INC $13C5
		AND #$1F
	+
		CMP #$10
		BCC +
		INC $13C5
		AND #$0F
	+
		CMP #$08
		BCC +
		INC $13C5
		AND #$07
	+
		CMP #$04
		BCC +
		INC $13C5
		AND #$03
	+
		CMP #$02
		BCC +
		INC $13C5
		AND #$01
	+
		CMP #$01
		BCC +
		INC $13C5
	+
		RTS

	NewGen:
		LDA #$01
		STA $9C
		JSL $00BEB0
		PLY
		REP #$20
		LDA $98
		CPY #$2D
		BNE .NotTopTile
		CLC
		ADC.w #$0010
		BRA .SetY
		.NotTopTile
		SEC
		SBC.w #$0010
		.SetY
		STA $98
		SEP #$20
		LDA #$01
		STA $9C
		JSL $00BEB0
		JML $00F373

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;owspeed

	!Speed		= $01		;    $01 = twice     the    original    speed,
					;    $02 = three  times  the  original  speed,
					;    [...] $FF = 256 times the original speed.

					;    ($00   will  keep   the  original  speed,
					;    ruining the point of this patch.)


	!YoshiSpeed	= $01		;    Speed  to  use   while  riding  on  Yoshi
					;    (same values as above).

	org $048244				;    Hijack Game Mode 0E ("On Overworld")
		autoclean JML ApplySpeed

	freecode
	reset bytes
	;print " Inserted at $",pc

	ApplySpeed:

		LDY #!Speed			;    Load speed value into Y

		LDA $0DD6 : LSR #2 : TAX	; \
		LDA $0DBA,x			;  | If the player is on Yoshi,
		BEQ .noYoshi			;  | load the Yoshi speed value instead
		LDY #!YoshiSpeed		; /

	.noYoshi


	.loop	
		TYA				; \
		BEQ .return			;  |
						;  | Then all we need to do
		PHY				;  | is execute SMW's OW speed routine Y times.
		JSR .runSpeedRoutine		;  |
		PLY				;  | (Each iteration makes it go faster, of course.)
						;  |
		DEY				;  |
		BRA .loop			; /


	.return
		LDX #$01			; \
		LDA $0DA6,x			;  | Restore the hijacked code and return
		JML $848264			; FIXED

	.runSpeedRoutine

		LDA $13D9			; \
		CMP #$04			;  |
		BNE ..return			;  | Don't do this if the player isn't walking,
		LDA $13D4			;  | the game is paused
		BNE ..return			;  | or the ground is shaking
		LDA $1BA0			;  |
		BNE ..return			; /

		PHK				; \
		PEA.w ..return-1		;  | Run SMW's OW speed routine
		PEA.w $048575-1			;  |
		JML $04945D			; /
	..return
		RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;spikeswimfix

	org $00F5FC
		autoclean JSL Main

	freecode

	Main: ;Main: is such an useful label name when you don't have any better ideas
		LDA #$01
		STA $71
		LDA #$04
		TRB $15
		RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;double spinjump antifail + relative y spd
	org $01A8B0
		autoclean JML DoubleSpin

	freespace noram
	DoubleSpin:
		LDA $7D
		BPL .Downwards
		SEC
		SBC $AA,x
		BPL .Downwards

		LDY #$03
		LDA #$02
	.Loop:
		CMP $17C0,y
		BEQ .DownCheck
		DEY
		BPL .Loop

		JML $01A8B4

	.DownCheck:
		;probably not needed
	.Downwards:
		JML $01A8C0



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;no cape rng (disabled)
;
;		LDA $14A6
;		CMP #$01
;		BNE NoTurn
;
;		LDA $15
;		AND #$01
;		BNE GoRightMaybe
;		STZ $76
;		BRA DoneTurning
;
;	GoRightMaybe:
;		LDA $15
;		AND #$02
;		BNE DoneTurning
;		LDA #$01
;		STA $76
;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;pitfix (disabled)

	org $00F5A5
		autoclean JML MovePit
		nop #1

	freecode
	MovePit:
		LDA $81
		DEC
		BMI +
		JML $80F5AA
	+
		JML $80F5B6


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;7E0071_fix

!pipe_dir = $60			;>this controls the directions within a pipe.

	org $00C5CE			;\fix hdma issues (like message box) when setting
		nop #8				;/$7E0071 to #$0B.

	org $01ED44			;\fix getting on yoshi automatically when entering
		autoclean JML Fix2		;/horizontal pipes while ovelapping yoshi's saddle.


	freecode

	Fix2:
		LDA $7D			;\Restore speed check in order to get on yoshi.
		BMI +			;/
		LDA !pipe_dir		;>for some reason, checking $7E0071 (probably because it doesn't assume the
					; values for it yet) doesn't work, so I had to check pipe direction instead.
	;	ORA !Cusfreeram		;>In case if you want to disable mounting yoshi in other ways.
		BNE +
		JML $01ED48		;|
	+	JML $01ED70		;/>Don't get on yoshi.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;overworld menu

org $048378
autoclean JML OWMenu

org $048281
autoclean JML ExtendOWPrompt

freecode
OWMenu:
	LDA $13D9
	CMP #$03
	BNE +
	LDA $18
	AND #$F0
	BNE +
	LDA $16
	CMP #$10
	BEQ .info
	CMP #$20
	BNE +
	JSR CallSave
	BRA +
.info
	LDA $02
	PHA
	JSR GetTranslevel
	LDA $02
	BEQ ++
	LDA #$09
	STA $1B87
++
	PLA
	STA $02
+
	JML $84839A

GetTranslevel:
	ldy.w $0dd6		;get current player*4
	lda.w $1f17,y		;ow player X position low
	lsr #4
	sta.b $00
	lda.w $1f19,y		;ow player y position low
	and.b #$f0
	ora.b $00
	sta.b $00
	lda.w $1f1A,y		;ow player y position high
	asl
	ora.w $1f18,y		;ow player x position high
	ldy.w $0db3		;get current player
	ldx.w $1f11,y		;get current map
	beq +
	clc : adc.b #$04		;if on submap, add $0400
+
	sta.b $01

	rep #$10
	ldx.b $00
	lda.l $7ed000,x		;load layer 1 tilemap, and thus current translevel number
	STA $02
	LDA.l $7FC800,x
	BEQ +
	LDA $02
	AND #$1F
	CLC
	ADC #$60
	STA $02
+
	sep #$10
.ret
	RTS


ExtendOWPrompt:
	LDA $1B87
	BEQ +
	CMP #$09
	BCS ++
	JML $848286
+
	JML $848295
++
	JSR LevelInfo
	JML $848413


LevelInfo:
	SEC
	SBC #$09
	JSL $8086DF
	dw .0
	dw .1
	dw .2
	dw .1

.0
	LDA #$22
	STA $1DFC
	INC $1B87

	LDY $0681
	LDA #$02
	STA $0682,y
	LDA #$1E
	STA $0683,y
	LDA #$00
	STA $0684,y
	LDA #$00
	STA $0685,y
	LDA #$00
	STA $0686,y
	TYA
	CLC
	ADC #$04
	STA $0681
-
	STZ $41
	STZ $42
	STZ $43
	LDA #$80
	TRB $0D9F
	RTS

.1
	LDX $1B88
	LDA $1B89
	CMP.l $04F413,x
	BNE ++
	INC $1B87
	LDA $1B87
	CMP #$0B
	BNE +
	JSR .letter
	RTS
+
	DEC
	AND #$03
	BNE +
	; terminate
	STZ $1B87
	STZ $1B88

	LDY $0681
	LDA #$02
	STA $0682,y
	LDA #$1E
	STA $0683,y
	LDA #$3B
	STA $0684,y
	LDA #$57
	STA $0685,y
	LDA #$00
	STA $0686,y
	TYA
	CLC
	ADC #$04
	STA $0681
	BRA -
+
	RTS

++
	PHK
	PEA .pos-1
	PEA $F6CE
	JML $84F44B
.pos
	RTS

.letter
	PHB
	PHY
	LDA $00
	PHA
	LDA $01
	PHA
	LDA $02
	PHA
	LDA $03
	PHA
	LDA $04
	PHA
	PHK
	PLB
	LDX.b #.lvinfoend-.lvinfo-1
-
	LDA .lvinfo,x
	STA $7F837D,x
	DEX
	BPL -

	JSR GetTranslevel
	LDA $02
	ASL
	TAY
	REP #$20
	LDA .pointers+2,y
	SEC
	SBC .pointers,y
	SEP #$20
	STZ $01
	CMP #$16
	BCC +
	INC $01
+
	LDX.b #.lvinfoend-.lvinfo
	REP #$20
	LDA .pointers,y
	STA $03
	SEP #$20
	STZ $00
-
	LDA $00
	ASL
	TAY
	REP #$20
	LDA .offset,y
	STA $7F837D,x
	LDA #$2900
	STA $7F837F,x
	SEP #$20
	INX #4

	LDY #$00
--
	LDA ($03),y
	STA $7F837D,x
	LDA #$3D
	STA $7F837E,x
	INX
	INX
	INY
	CPY #$15
	BMI --

	REP #$20
	LDA $03
	CLC
	ADC #$0015
	STA $03
	SEP #$20

	INC $00
	LDA $00
	DEC
	CMP $01
	BMI -
	
	; exit num
	REP #$20
	LDY $02
	LDA #$D751
	STA $7F837D,x
	LDA #$0900
	STA $7F837F,x
	LDA #$3D32
	STA $7F8381,x
	LDA #$3D33
	STA $7F8383,x
	LDA #$3CFF
	STA $7F8385,x
	LDA #$3C26
	STA $7F8387,x
	SEP #$20
	LDA .exitnum,y
	STA $7F8389,x
	LDA #$3C
	STA $7F838A,x
	INX #14

	LDA #$FF
	STA $7F837D,x
	TXA
	REP #$20
	AND #$00FF
	STA $7F837B
	SEP #$20

	; levelinfo
	LDA $02
	REP #$20
	AND #$00FF
	ASL
	ASL
	CLC
	ADC #.infolist
	STA $03
	SEP #$20

	LDY #$03
	LDX #$03
-
	LDA ($03),y
	STA $7FB800,x
	DEX
	DEY
	BPL -

	LDA #$00
	STA $7FB804
	PLA
	STA $04
	PLA
	STA $03
	PLA
	STA $02
	PLA
	STA $01
	PLA
	STA $00
	PLY
	PLB
	JSR .drawinfo
	RTS

.lvinfo
	db $51,$84,$00,$2D
	db $70,$3D,$73,$3D,$80,$3C,$73,$3D,$70,$3D,$FC,$38,$82,$3C,$30,$3D,$34,$3D,$7A,$3C,$FC,$38,$FC,$38,$FC,$38	; LEVEL INFO
	;db $51,$91,$00,$13
	db $35,$19,$FC,$38,$FC,$38,$35,$19,$FC,$38,$FC,$38,$35,$19,$FC,$38,$FC,$38,$35,$19
	db $51,$E6,$00,$13
	;db $71,$3D,$7B,$3C,$2F,$3D,$84,$3C,$7A,$3C,$74,$3D	; AUTHOR
	;db $0A,$3C,$1E,$3C,$1D,$3C,$11,$3C,$18,$3C,$1B,$3C	; AUTHOR
	db $2D,$3D,$74,$3D,$73,$3D,$71,$3D,$2F,$3D,$73,$3D,$7C,$3C,$FC,$38,$2C,$3D,$72,$3D	; CREATED BY
.lvinfoend
.offset
	db $52,$26,$52,$46

.2
	LDA $16
	AND #$F0
	BNE +
	LDA $18
	AND #$C0
	BEQ ++
+
	PHB
	PHK
	PLB
	INC $1B87
	INC $1B88
	REP #$20
	LDA #$0025
	STA $7F837B
	SEP #$20
	DEC
	TAX
-
	LDA .clear,x
	STA $7F837D,x
	DEX
	BPL -
	PLB
++
	JSR .drawinfo
	RTS

.drawinfo
	PHB
	PHY
	PHK
	PLB
	REP #$20
	LDA $00
	PHA
	LDA $02
	PHA
	LDA $04
	PHA
	LDA $06
	PHA
	SEP #$20

	LDA #$00
	STA $7FB7EF

	;STZ $1FFF
	STZ $07
	LDX #$00
-
	LDA $7FB800,x
	BEQ +
	DEC
	ASL
	TAY
	CMP #$10
	BNE ++
	PHY
	INY
	INY
	JSR .drawfunc_pre
	PLY
++
	JSR .drawfunc_pre
	INC $07
	INC $07
+
	INX
	CPX #$05
	BMI -

	REP #$20
	PLA
	STA $06
	PLA
	STA $04
	PLA
	STA $02
	PLA
	STA $00
	SEP #$20
	PLY
	PLB
	RTS

.proptile
	dw $3AA0,$38A2,$36C2,$3AC0,$34A7,$38AE,$38A9,$3CCE,$32AB,$32AC
.dx
	dw $0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$FFFC,$0004
.dy
	dw $0000,$0000,$0000,$0000,$0001,$0000,$0000,$0000,$FFFF,$FFFF
.x
	dw $0084,$009C,$00B4,$00CC,$00CC
.y
	dw $005B,$005B,$005B,$005B,$006F


.drawfunc_pre
	REP #$20
	LDA .proptile,y
	STA $04
	LDA .dx,y
	STA $00
	LDA .dy,y
	STA $02
	LDY $07
	LDA .x,y
	CLC
	ADC $00
	STA $00
	LDA .y,y
	CLC
	ADC $02
	STA $02
	SEP #$20
	LDA #$02
	STA $06
;$00 = x(scr)
;$02 = y(scr)
;$04 = prop(h)/tile(l)
;$06 = 0(8*8)/2(16*16)
;x is preserved
.drawfunc
	REP #$20

	LDA $00
	CMP #$FFF1	; allowing -000F~0100
	BCS +
	CMP #$0100
	BCS .not_draw2
+
	LDA $02
	CMP #$FFF1	; allowing -000F~00F0
	BCS +
	CMP #$00F0
	BCC +
.not_draw1
.not_draw2
	SEP #$20
	RTS
+
	SEP #$20
	PHX

	LDA $7FB7EF
	AND #$FC
	TAX
-
	CPX #$FC
	BCS ++
	LDA $0301,x
	CMP #$F0
	BEQ ++
+
	INX
	INX
	INX
	INX
	BRA -
++
	TXA
	STA $7FB7EF

.draw_cont
	LDA $00
	STA $0300,x	; x

	LDA $02
	STA $0301,x	; y

	REP #$20
	LDA $04
	STA $0302,x	; tile & prop
	SEP #$20

	TXA
	LSR
	LSR
	TAX
	LDA $01
	BNE .off
	LDA $06
	STA $0460,x
	PLX
	RTS
.off
	LDA $06
	INC
	STA $0460,x
	PLX
	RTS

.clear
	db $51,$84,$40,$2E,$FC,$38
	db $51,$E6,$40,$14,$FC,$38
	;db $51,$E6,$40,$2A,$FC,$38
	db $52,$26,$40,$2A,$FC,$38
	db $52,$46,$40,$2A,$FC,$38
	db $51,$D4,$40,$0E,$FC,$38
	db $FF
.clearend

incsrc levelinfodata.asm

.pointers
	dw AuthorsTable_level000
	dw AuthorsTable_level001
	dw AuthorsTable_level002
	dw AuthorsTable_level003
	dw AuthorsTable_level004
	dw AuthorsTable_level005
	dw AuthorsTable_level006
	dw AuthorsTable_level007
	dw AuthorsTable_level008
	dw AuthorsTable_level009
	dw AuthorsTable_level00A
	dw AuthorsTable_level00B
	dw AuthorsTable_level00C
	dw AuthorsTable_level00D
	dw AuthorsTable_level00E
	dw AuthorsTable_level00F
	dw AuthorsTable_level010
	dw AuthorsTable_level011
	dw AuthorsTable_level012
	dw AuthorsTable_level013
	dw AuthorsTable_level014
	dw AuthorsTable_level015
	dw AuthorsTable_level016
	dw AuthorsTable_level017
	dw AuthorsTable_level018
	dw AuthorsTable_level019
	dw AuthorsTable_level01A
	dw AuthorsTable_level01B
	dw AuthorsTable_level01C
	dw AuthorsTable_level01D
	dw AuthorsTable_level01E
	dw AuthorsTable_level01F
	dw AuthorsTable_level020
	dw AuthorsTable_level021
	dw AuthorsTable_level022
	dw AuthorsTable_level023
	dw AuthorsTable_level024
	dw AuthorsTable_level101
	dw AuthorsTable_level102
	dw AuthorsTable_level103
	dw AuthorsTable_level104
	dw AuthorsTable_level105
	dw AuthorsTable_level106
	dw AuthorsTable_level107
	dw AuthorsTable_level108
	dw AuthorsTable_level109
	dw AuthorsTable_level10A
	dw AuthorsTable_level10B
	dw AuthorsTable_level10C
	dw AuthorsTable_level10D
	dw AuthorsTable_level10E
	dw AuthorsTable_level10F
	dw AuthorsTable_level110
	dw AuthorsTable_level111
	dw AuthorsTable_level112
	dw AuthorsTable_level113
	dw AuthorsTable_level114
	dw AuthorsTable_level115
	dw AuthorsTable_level116
	dw AuthorsTable_level117
	dw AuthorsTable_level118
	dw AuthorsTable_level119
	dw AuthorsTable_level11A
	dw AuthorsTable_level11B
	dw AuthorsTable_level11C
	dw AuthorsTable_level11D
	dw AuthorsTable_level11E
	dw AuthorsTable_level11F
	dw AuthorsTable_level120
	dw AuthorsTable_level121
	dw AuthorsTable_level122
	dw AuthorsTable_level123
	dw AuthorsTable_level124
	dw AuthorsTable_level125
	dw AuthorsTable_level126
	dw AuthorsTable_level127
	dw AuthorsTable_level128
	dw AuthorsTable_level129
	dw AuthorsTable_level12A
	dw AuthorsTable_level12B
	dw AuthorsTable_level12C
	dw AuthorsTable_level12D
	dw AuthorsTable_level12E
	dw AuthorsTable_level12F
	dw AuthorsTable_level130
	dw AuthorsTable_level131
	dw AuthorsTable_level132
	dw AuthorsTable_level133
	dw AuthorsTable_level134
	dw AuthorsTable_level135
	dw AuthorsTable_level136
	dw AuthorsTable_level137
	dw AuthorsTable_level138
	dw AuthorsTable_level139
	dw AuthorsTable_level13A
	dw AuthorsTable_level13B
	dw AuthorsTable_level1E0
	dw AuthorsTable_level1E1
	dw AuthorsTable_level1E2
	dw AuthorsTable_level1E3
	dw AuthorsTable_level1E4
	dw AuthorsTable_level1E5
	dw AuthorsTable_level1E6
	dw AuthorsTable_level1E7
	dw AuthorsTable_level1E8
	dw AuthorsTable_level1E9
	dw AuthorsTable_level1EA
	dw AuthorsTable_level1EB
	dw AuthorsTable_level1EC
	dw AuthorsTable_level1ED
	dw AuthorsTable_level1EE
	dw AuthorsTable_level1EF
	dw AuthorsTable_level1F0
	dw AuthorsTable_level1F1
	dw AuthorsTable_level1F2
	dw AuthorsTable_level1F3
	dw AuthorsTable_level1F4
	dw AuthorsTable_level1F5
	dw AuthorsTable_level1F6
	dw AuthorsTable_level1F7
	dw AuthorsTable_eof

AuthorsTable:
	incsrc AuthorData.asm
.eof


CallSave:
	LDX #$5F
-
	LDA $1EA2,x
	STA $1F49,x
	DEX
	BPL -
	LDX #$2C
-
	LDA $1F02,x
	STA $1FA9,x
	DEX
	BPL -
	REP #$30
	LDX $0DD6
	TXA
	EOR #$0004
	TAY
	LDA $1FBE,x
	STA $1FBE,y
	LDA $1FC0,x
	STA $1FC0,y
	LDA $1FC6,x
	STA $1FC6,y
	LDA $1FC8,x
	STA $1FC8,y
	TXA
	LSR
	TAX
	EOR #$0002
	TAY
	LDA $1FBA,x
	STA $1FBA,y
	TXA
	SEP #$30
	LSR
	TAX
	EOR #$01
	TAY
	LDA $1FB8,x
	STA $1FB8,y

	LDA #$05
	STA $1B87
	RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;custom hud

; 2nd~3rd (110 bytes)
; static
org $008C89
	db $fc,$38,$fc,$38,$fc,$38,$fc
	db $38,$fc,$38,$fc,$38,$16,$2c,$0a,$2c,$1b,$2c,$12,$2c,$18,$2c,$fc
	db $38,$4a,$38,$fc,$38,$fc,$38,$4a,$78,$fc,$38,$fc,$2c,$fc,$2c,$fc
	db $2c,$fc,$2c,$fc,$38,$fc,$38,$fc,$38,$fc,$38,$fc,$38,$fc,$38,$fc
	db $38,$fc,$38,$fc,$38,$fc,$38,$fc,$38,$fc,$38,$fc,$38,$26,$38,$fc
	db $38,$00,$38,$fc,$38,$fc,$38,$4a,$38,$fc,$38,$fc,$38,$4a,$78,$fc
	db $38,$2e,$3c,$fc,$38,$00,$38,$fc,$38,$fc,$38,$fc,$38,$fc,$38,$fc
	db $38,$fc,$38,$fc,$38,$fc,$38

	!RAM_BAR	= $7FA200	; Free ram for status bar (needs $140 (320 decimal) bytes)

; Valid numbers for these offsets: $000-$13F
; Use even numbers ONLY!
; Properties (palette/ect) are set in the DATA_TILES tables, or using Smallhacker's status bar editor
; They are not updated automatically if you just change these 
; If you move the time counter, for example, it will probably be white until you change the properties byte of the tiles it writes to
	!TIME_OFFSET 	= $0B2		; Position of "TIME" timer (not TIME itself)
	!SCORE_OFFSET	= $0EE		; disabled
	!LIVES_OFFSET	= $0D4		; Position of lives counter
	!COINS_OFFSET	= $0E8		; Position of coin counter
	!NAME_OFFSET	= $090		; Position of player name (MARIO/LUIGI)
	!DRAGON_OFFSET	= $0A6		; Position of dragon coins (yoshi coins, whatever)
	!STARS_OFFSET	= $0D8		; disabled

	!bar_no = $0EF9			; which status bar would be displayed

org $008CFF
	JMP SkipInit


ORG $008D8A		; hijack status bar initilization routine
SkipInit:
	autoclean JSL MAIN_2
	NOP		; fill in a byte

ORG $008DB6
	BRA SKIP_UNUSED		; skip past unused code
				; This spot was chosen for compatibility with sprite status bar and stripe image uploader
				; (sprite status bar requires some RAM address tweaks within it's code to be compatible with this)

ORG $008DE2			; near end of DrawStatusBar
SKIP_UNUSED:
	autoclean JSL MAIN 			;Point to new routine

	RTS


ORG $008E1A			; hijack routine that updates status bar tiles in RAM
	autoclean JML MAIN_3

ORG $0090D0		; make this into a JSL routine instead JSR
	RTL


org $009090
	autoclean JML ItemBox

freecode
DATA_TILES:			; This is the data for the tiles not regularly uploaded by SMW
	db $FC,$38		; First number is the tile number, second is the properties
	db $FC,$38		; YXPCCCTT
	db $FC,$38		; Y = y flip, X = flip, P = priority, CCC = palette number (4 color palettes remember)
	db $FC,$38		; TT = page number
	db $FC,$38		; Ex: 38 = 00111000
	db $FC,$38		; priority bit set, palette 7 (of 8)
	db $FC,$38		; FC is a blank tile with SMW's original l3 graphics
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38		; This whole block is for the line above the top of the item box
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38

DATA_TILES2:			; Start of second line
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	;
	; Item box would be here. Already DMA'd in SMW's regular code
	; Not included here for compatibility with the status bar editor tool
	;
DATA_TILES3:
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
DATA_TILES4:
	; two tiles at the upper middle left
	db $FC,$38
	db $FC,$38
DATA_TILES5:
	; two tiles at the upper middle right
	db $FC,$38
	db $FC,$38
DATA_TILES6:
	; three tiles at the lower middle left
	db $FC,$38
	db $FC,$38
	db $FC,$38
DATA_TILES7:
	; two tiles at the lower middle right
	db $FC,$38
	db $FC,$38
DATA_TILES8:
	; bottom row
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	;
	; Item box would be here. Already DMA'd in SMW's regular code
	; Not included here for compatibility with the status bar editor tool
	;
DATA_TILES9:
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38
	db $FC,$38


DMA_Pointers:
	dw DMA_BAR1
	dw DMA_BAR2

DMA_BAR1:
	db $01,$18,$00,$A2,$7F,$40,$01
	db $01	; display itembox item flag
DMA_BAR2:
	db $01,$18,$40,$A3,$7F,$40,$01
	db $00	; display itembox item flag


MAIN_2:				; Uploads tiles to ram and DMAs new tiles
	PHB
	PHK
	PLB
	PHY
	PHX

	PHB
	LDA #$00		; set bank to 00
	PHA
	PLB
	
	REP #$10		; 16 bit X Y

	LDY #$0007		; 
	LDX #$0063		; Upload status bar tiles to ram
UPLOAD_STATBAR1:		; 
	LDA $8C81,y		; Top of item box
	STA !RAM_BAR,X		; 
	DEX
	DEY
	BPL UPLOAD_STATBAR1
	LDY #$0037		; top middle of status bar
	LDX #$00BB
UPLOAD_STATBAR2:
	LDA $8C89,Y
	STA !RAM_BAR,X
	DEX
	DEY
	BPL UPLOAD_STATBAR2
	LDY #$0035		; low middle of status bar
	LDX #$00FB
UPLOAD_STATBAR3:
	LDA $8CC1,Y
	STA !RAM_BAR,X
	DEX
	DEY
	BPL UPLOAD_STATBAR3
	LDY #$0007		; bottom of item box
	LDX #$0123
UPLOAD_STATBAR4:
	LDA $8CF7,Y
	STA !RAM_BAR,X
	DEX
	DEY
	BPL UPLOAD_STATBAR4

	PLB			; reset bank

	LDY #$005B		; get tiles from here and store to RAM
	LDX #$005B
UPLOAD_STATBAR5:
	LDA DATA_TILES,Y
	STA !RAM_BAR,x
	DEX
	DEY
	BPL UPLOAD_STATBAR5

	LDY #$001F		
	LDX #$0083
UPLOAD_STATBAR6:
	LDA DATA_TILES3,Y
	STA !RAM_BAR,x
	DEX
	DEY
	BPL UPLOAD_STATBAR6

	LDY #$0009		
	LDX #$00C5
UPLOAD_STATBAR7:
	LDA DATA_TILES5,Y
	STA !RAM_BAR,x
	DEX
	DEY
	BPL UPLOAD_STATBAR7

	LDY #$001F		
	LDX #$011B
UPLOAD_STATBAR8:
	LDA DATA_TILES7,Y
	STA !RAM_BAR,x
	DEX
	DEY
	BPL UPLOAD_STATBAR8

	LDY #$001B		
	LDX #$013F
UPLOAD_STATBAR9:
	LDA DATA_TILES9,Y
	STA !RAM_BAR,x
	DEX
	DEY
	BPL UPLOAD_STATBAR9

      	LDA #$28                ; Recover old code
      	STA $0F30               ; #$28 -> Timer frame counter 

	STZ !bar_no		; init -> default bar

DMA_STATBAR:	

	SEP #$10	; 8 bit X Y
	LDA !bar_no
	ASL
	TAX
	REP #$20
	LDA DMA_Pointers,x
	STA $06
	SEP #$20

	LDA #$80
	STA $2115
	LDA #$00
	STA $2116	; DMA it
	LDA #$50
	STA $2117
	LDY #$06
DMA_LOOP:
	LDA ($06),y
	STA $4310,y
	DEY
	BPL DMA_LOOP
	LDA #$02
	STA $420B	

	PLX
	PLY
	PLB



	RTL


MAIN:	PHB
	PHY
	PHX		; wrapper thingy

	PHK
	PLB

	; If you would like to add any subroutines that are run every frame the status bar is, 
	; feel free to stick them right here

	JMP DMA_STATBAR


;REPLAY:
;	db $FC,$0D,$0E,$16,$18,$FC
;	db $FC,$FC,$FC,$FC,$FC,$FC

DATA_008DF5:                      db $15,$1E,$12,$10,$12

DATA_008E06:                      db $B7

DATA_008E07:                      db $C3,$B8,$B9,$BA,$BB,$BA,$BF,$BC
                                  db $BD,$BE,$BF,$C0,$C3,$C1,$B9,$C2
                                  db $C4,$B7,$C5

MAIN_3:
	PHB
	PHK
	PLB		; wrapper
			; Basically copy/pasted code from all.log
			; modified to use new RAM addresses

CODE_008E1A:        LDA $1493               ; \  
CODE_008E1D:        ORA $9D     ;  |If level is ending or sprites are locked, 
CODE_008E1F:        BNE CODE_008E6F           ; / branch to $8E6F 
CODE_008E21:        LDA $0D9B               
CODE_008E24:        CMP #$C1                
CODE_008E26:        BEQ CODE_008E6F         
		LDA $0F30
		BMI CODE_008E6F
CODE_008E28:        DEC $0F30               
CODE_008E2B:        BPL CODE_008E6F           
CODE_008E2D:        LDA #$28                
CODE_008E2F:        STA $0F30               
CODE_008E32:        LDA $0F31               ; \  
CODE_008E35:        ORA $0F32               ;  |If time is 0, 
CODE_008E38:        ORA $0F33               ;  |branch to $8E6F 
CODE_008E3B:        BEQ CODE_008E70           ; /  

CODE_008E3D:        LDX #$02                
CODE_008E3F:        DEC $0F31,X             
CODE_008E42:        BPL CODE_008E4C           
CODE_008E44:        LDA #$09                
CODE_008E46:        STA $0F31,X             
CODE_008E49:        DEX                       
CODE_008E4A:        BPL CODE_008E3F           

CODE_008E4C:        LDA $0F31               ; \  
CODE_008E4F:        BNE CODE_008E71           ;  | 
CODE_008E51:        LDA $0F32               ;  | 
CODE_008E54:        AND $0F33               ;  |If time is 99, 
CODE_008E57:        CMP #$09                ;  |speed up the music 
CODE_008E59:        BNE CODE_008E60           ;  | 
CODE_008E5B:        LDA #$FF                ;  | 
CODE_008E5D:        STA $1DF9               ;  | 

CODE_008E60:
		LDA $0F32
		ORA $0F33
		BNE CODE_008E71
		LDA #$FF
		STA $0F30
		JSL $00F606

; skip timer only if there's no time limit
CODE_008E6F:
;		LDA $13BF
;		CMP #$24
;		BNE +
;		LDA $141A
;		CMP #$03
;		BCC +
;		; replay
;		LDY #$05
;		LDA $14
;		AND #$1F
;		CMP #$08
;		BCS ++
;		LDY #$0B
;++
;		LDX #$0A
;-
;		LDA $0EF9
;		BEQ .0
;		LDA REPLAY,y
;		STA $7FA340+!TIME_OFFSET-2,x
;		BRA .1
;.0
;		LDA REPLAY,y
;		STA !RAM_BAR+!TIME_OFFSET-2,x
;.1
;		DEY
;		DEX
;		DEX
;		BPL -
;		BRA CODE_008E95
;+
		LDA $0F31
		ORA $0F32
		ORA $0F33
		BNE CODE_008E71
CODE_008E70:
		LDA $0F30
		CMP #$FF
		BNE CODE_008E95
CODE_008E71:
		LDA $0F31               ; \  
CODE_008E72:        STA !RAM_BAR+!TIME_OFFSET              ;  | 
CODE_008E75:        LDA $0F32               ;  |Copy time to $0F25-$0F27 
CODE_008E78:        STA !RAM_BAR+!TIME_OFFSET+2              ;  | 
CODE_008E7B:        LDA $0F33               ;  | 
CODE_008E7E:        STA !RAM_BAR+!TIME_OFFSET+4              ; /  
CODE_008E81:        LDX #$00                
CODE_008E83:        LDY #$00                
CODE_008E85:        LDA $0F31,Y             

; put timer icon
		LDA #$76
		STA !RAM_BAR+!TIME_OFFSET-2
; leave leading zeroes
CODE_008E88:        BRA CODE_008E95           

CODE_008E8A:        LDA #$FC                
CODE_008E8C:        STA !RAM_BAR+!TIME_OFFSET,X             
CODE_008E8F:        INY                       
CODE_008E90:        INX 
		INX                      
CODE_008E91:        CPY #$02                
CODE_008E93:        BNE CODE_008E85           


CODE_008E95:        LDX #$03                
CODE_008E97:        LDA $0F36,X             
CODE_008E9A:        STA $00                   
CODE_008E9C:        STZ $01                   
CODE_008E9E:        REP #$20                  ; 16 bit A ; Accum (16 bit) 
CODE_008EA0:        LDA $0F34,X             
CODE_008EA3:        SEC                       
CODE_008EA4:        SBC #$423F              
CODE_008EA7:        LDA $00                   
CODE_008EA9:        SBC #$000F              
CODE_008EAC:        BCC CODE_008EBF           
ADDR_008EAE:        SEP #$20                  ; 8 bit A ; Accum (8 bit) 
ADDR_008EB0:        LDA #$0F                
ADDR_008EB2:        STA $0F36,X             
ADDR_008EB5:        LDA #$42                
ADDR_008EB7:        STA $0F35,X             
ADDR_008EBA:        LDA #$3F                
ADDR_008EBC:        STA $0F34,X             
CODE_008EBF:        SEP #$20                  ; 8 bit A ; Accum (8 bit) 
CODE_008EC1:        DEX                       
CODE_008EC2:        DEX                       
CODE_008EC3:        DEX                       
CODE_008EC4:        BPL CODE_008E97           

; skip score counter
; but score may be calculated secretly
		BRA CODE_008F1D

CODE_008EC6:        LDA $0F36               ; \ Store high byte of Mario's score in $00 
CODE_008EC9:        STA $00                   ; /  
CODE_008ECB:        STZ $01                   ; Store x00 in $01 
CODE_008ECD:        LDA $0F35               ; \ Store mid byte of Mario's score in $03 
CODE_008ED0:        STA $03                   ; / 
CODE_008ED2:        LDA $0F34               ; \ Store low byte of Mario's score in $02 
CODE_008ED5:        STA $02                   ; / 
CODE_008ED7:        LDX #$00                
CODE_008ED9:        LDY #$00                
CODE_008EDB:        JSR CODE_009012   
CODE_008EDE:        LDX #$00                ; \  
CODE_008EE0:        LDA !RAM_BAR+!SCORE_OFFSET,X             ;  | 
CODE_008EE3:        BNE CODE_008EEF           ;  | 
CODE_008EE5:        LDA #$FC                ;  |Replace all leading zeroes in the score with spaces 
CODE_008EE7:        STA !RAM_BAR+!SCORE_OFFSET,X             ;  | 
CODE_008EEA:        INX                       ;  | 
		INX
CODE_008EEB:        CPX #$0C                ;  | 
CODE_008EED:        BNE CODE_008EE0           ;  | 
CODE_008EEF:        LDA $0DB3               ; Get current player 
CODE_008EF2:        BEQ CODE_008F1D           ; If player is Mario, branch to $8F1D 
CODE_008EF4:        LDA $0F39               ; \ Store high byte of Luigi's score in $00 
CODE_008EF7:        STA $00                   ; /  
CODE_008EF9:        STZ $01                   ; Store x00 in $01 
CODE_008EFB:        LDA $0F38               ; \ Store mid byte of Luigi's score in $03 
CODE_008EFE:        STA $03                   ; /  
CODE_008F00:        LDA $0F37               ; \ Store low byte of Luigi's score in $02 
CODE_008F03:        STA $02                   ; /  
CODE_008F05:        LDX #$00                
CODE_008F07:        LDY #$00                
CODE_008F09:        JSR CODE_009012         
CODE_008F0C:        LDX #$00                ; \  
CODE_008F0E:        LDA !RAM_BAR+!SCORE_OFFSET,X             ;  | 
CODE_008F11:        BNE CODE_008F1D           ;  | 
CODE_008F13:        LDA #$FC                ;  |Replace all leading zeroes in the score with spaces 
CODE_008F15:        STA !RAM_BAR+!SCORE_OFFSET,X             ;  | 
CODE_008F18:        INX                       ;  | 
		INX
CODE_008F19:        CPX #$0C                ;  | 
CODE_008F1B:        BNE CODE_008F0E           ; /  


CODE_008F1D:        LDA $13CC               ; \ If Coin increase isn't x00, 
CODE_008F20:        BEQ CODE_008F3B           ; / branch to $8F3B 
CODE_008F22:        DEC $13CC               ; Decrease "Coin increase" 
CODE_008F25:        INC $0DBF     ; Increase coins by 1 
CODE_008F28:        LDA $0DBF     ; \  
CODE_008F2B:        CMP #$64                ;  |If coins<100, branch to $8F3B 
CODE_008F2D:        BCC CODE_008F3B           ; /  
CODE_008F2F:        INC $18E4               ; Increase lives by 1 
CODE_008F32:        LDA $0DBF    ; \  
CODE_008F35:        SEC                       ;  |Decrease coins by 100 
CODE_008F36:        SBC #$64                ;  | 
CODE_008F38:        STA $0DBF     ; /  
CODE_008F3B:        LDA $0DBE     ; \ If amount of lives is negative, 
CODE_008F3E:        BMI CODE_008F49           ; / branch to $8F49 
CODE_008F40:        CMP #$62                ; \ If amount of lives is less than 98, 
CODE_008F42:        BCC CODE_008F49           ; / branch to $8F49 
CODE_008F44:        LDA #$62                ; \ Set amount of lives to 98 
CODE_008F46:        STA $0DBE     ; \  
CODE_008F49:        LDA $0DBE     ; \  
CODE_008F4C:        INC A                     ;  |Get amount of lives in decimal 
CODE_008F4D:        JSR HexToDec            ; /  
CODE_008F58:        STA !RAM_BAR+!LIVES_OFFSET+2               ; /  
CODE_008F50:        TXA                       ; \  
CODE_008F51:        BNE CODE_008F55           ;  |If 10s is 0, replace with space 
CODE_008F53:        LDA #$FC                ;  | 
CODE_008F55:        STA !RAM_BAR+!LIVES_OFFSET              ; \ Write lives to status bar 

; skip bonus game

CODE_008F5B:        LDX $0DB3               ; \ Get bonus stars 
CODE_008F5E:        LDA $0F48,X             ; /  
CODE_008F61:        CMP #$64                ; \ If bonus stars is less than 100, 
CODE_008F63:        BCC CODE_008F73           ; / branch to $8F73 
CODE_008F65:        ;LDA #$FF                ; \ Start bonus game when the level ends 
CODE_008F67:        ;STA $1425               ; /  
CODE_008F6A:        LDA $0F48,X             ; \  
CODE_008F6D:        SEC                       ;  |Subtract bonus stars by 100 
CODE_008F6E:        SBC #$64                ;  | 
CODE_008F70:        STA $0F48,X             ; /  
CODE_008F73:        
		LDA $0DBF     ; \ Get amount of coins in decimal 
CODE_008F76:        JSR HexToDec            ; /  
CODE_008F7E:        STA !RAM_BAR+!COINS_OFFSET+2               ; \ Write coins to status bar 
		TXA
		BNE CODE_008F81
CODE_008F7C:        LDA #$FC                ;  | 
CODE_008F81:        STA !RAM_BAR+!COINS_OFFSET               ; /  
CODE_008F84:        SEP #$20                  ; 8 bit A ; Accum (8 bit) 

; skip star counter
		BRA CODE_008FC4

CODE_008F86:        LDX $0DB3               ; Load Character into X 
CODE_008F89:        STZ $00                   
CODE_008F8B:        STZ $01                   
CODE_008F8D:        STZ $03                   
CODE_008F8F:        LDA $0F48,X             
CODE_008F92:        STA $02                   
CODE_008F94:        LDX #$00                
CODE_008F96:        LDY #$10                
CODE_008F98:        JSR CODE_009051         
CODE_008F9B:        LDX #$00                
CODE_008F9D:        LDA !RAM_BAR+!STARS_OFFSET,X             
CODE_008FA0:        BNE CODE_008FAF           
CODE_008FA2:        LDA #$FC                
CODE_008FA4:        STA !RAM_BAR+!STARS_OFFSET,X             
CODE_008FA7:        STA !RAM_BAR+!STARS_OFFSET-$40,X             
CODE_008FAA:        INX                    
		INX   
CODE_008FAB:        CPX #$02                
CODE_008FAD:        BNE CODE_008F9D           
CODE_008FAF:        LDA !RAM_BAR+!STARS_OFFSET,X             
CODE_008FB2:        ASL                       
CODE_008FB3:        TAY                       
CODE_008FB4:        LDA DATA_008E06,Y       
CODE_008FB7:        STA !RAM_BAR+!STARS_OFFSET-$40,X             
CODE_008FBA:        LDA DATA_008E07,Y       
CODE_008FBD:        STA !RAM_BAR+!STARS_OFFSET,X             
CODE_008FC0:        INX         
		INX              
CODE_008FC1:        CPX #$04                
CODE_008FC3:        BNE CODE_008FAF   


CODE_008FC4:		
		LDA #$00
		PHA
		PLB        
CODE_008FC5:        JSL $009079   ; Draw item box item sprite  
		PHK
		PLB    
CODE_008FC8:        LDA $0DB3               
CODE_008FCB:        BEQ CODE_008FD8           
CODE_008FCD:        LDY #$04      
		LDX #$09
CODE_008FCE:
		LDA #$28
		STA !RAM_BAR+!NAME_OFFSET,X 
		DEX
CODE_008FCF:        LDA DATA_008DF5,Y      
CODE_008FD2:        STA !RAM_BAR+!NAME_OFFSET,X             
		DEX             
CODE_008FD5:        DEY         
CODE_008FD6:        BPL CODE_008FCE           
CODE_008FD8:
		LDA $1422               
CODE_008FDB:        CMP #$05                
CODE_008FDD:        BCC CODE_008FE1           
CODE_008FDF:
		; write ALL DC
		LDA #$0A
		STA !RAM_BAR+!DRAGON_OFFSET
		LDA #$15
		STA !RAM_BAR+!DRAGON_OFFSET+2
		STA !RAM_BAR+!DRAGON_OFFSET+4
		LDA #$3C
		STA !RAM_BAR+!DRAGON_OFFSET+1
		STA !RAM_BAR+!DRAGON_OFFSET+3
		STA !RAM_BAR+!DRAGON_OFFSET+5
		LDA #$2E
		STA !RAM_BAR+!DRAGON_OFFSET+6
		BRA CODE_008FF9
CODE_008FE1:
		LDA $13BF
		AND #$07
		PHA
		LDA $13BF
		LSR #3
		TAX
		CPX #$0C
		BCC +
		LDA $7FA4A0-$C,x
		BRA ++
	+
		LDA $1F2F,x
	++
		PLX
		AND $0DA8A6,x
		BNE CODE_008FDF
		LDA $1422
		DEC A                     
CODE_008FE2:        STA $00                   
CODE_008FE4:        LDX #$00                
CODE_008FE6:        LDY #$FC                
CODE_008FE8:        LDA $00                   
CODE_008FEA:        BMI CODE_008FEE           
CODE_008FEC:        LDY #$2E                
CODE_008FEE:        TYA                       
CODE_008FEF:        STA !RAM_BAR+!DRAGON_OFFSET,X             
CODE_008FF2:        DEC $00                   
CODE_008FF4:        INX              
		INX         
CODE_008FF5:        CPX #$08                
CODE_008FF7:        BNE CODE_008FE6 
CODE_008FF9:
		PLB
		JML $008FF9	; return
	 	


DATA_008FFA:                      db $01,$00

DATA_008FFC:                      db $A0,$86,$00,$00,$10,$27,$00,$00
                                  db $E8,$03,$00,$00,$64,$00,$00,$00
                                  db $0A,$00,$00,$00,$01,$00

CODE_009012:        SEP #$20                  ; 8 bit A ; Accum (8 bit) 
		LDA #$00
CODE_009014:        STA !RAM_BAR+!SCORE_OFFSET,X             
CODE_009017:        REP #$20                  ; 16 bit A ; Accum (16 bit) 
CODE_009019:        LDA $02                   
CODE_00901B:        SEC                       
CODE_00901C:        SBC DATA_008FFC,Y       
CODE_00901F:        STA $06                   
CODE_009021:        LDA $00                   
CODE_009023:        SBC DATA_008FFA,Y       
CODE_009026:        STA $04                   
CODE_009028:        BCC CODE_009039           
CODE_00902A:        LDA $06                   
CODE_00902C:        STA $02                   
CODE_00902E:        LDA $04                   
CODE_009030:        STA $00                   
CODE_009032:        SEP #$20                  ; 8 bit A ; Accum (8 bit) 
CODE_009034:        LDA !RAM_BAR+!SCORE_OFFSET,X    
		INC A
		STA !RAM_BAR+!SCORE_OFFSET,x         
CODE_009037:        BRA CODE_009017           

CODE_009039:        INX   
		INX                    
CODE_00903A:        INY                       
CODE_00903B:        INY                       
CODE_00903C:        INY                       
CODE_00903D:        INY                       
CODE_00903E:        CPY #$18                
CODE_009040:        BNE CODE_009012           
CODE_009042:        SEP #$20                  ; 8 bit A ; Accum (8 bit) 
Return009044:       RTS       


HexToDec:           LDX #$00                ;  | 
CODE_009047:        CMP #$0A                ;  | 
CODE_009049:        BCC Return009050          ;  |Sets A to 10s of original A 
CODE_00904B:        SBC #$0A                ;  |Sets X to 1s of original A 
CODE_00904D:        INX                       ;  | 
CODE_00904E:        BRA CODE_009047           ;  | 

Return009050:       RTS                       ; / 

CODE_009051:        SEP #$20                  ; Accum (8 bit) 
		LDA #$00
CODE_009053:        STA !RAM_BAR+!STARS_OFFSET,X             
CODE_009056:        REP #$20                  ; Accum (16 bit) 
CODE_009058:        LDA $02                   
CODE_00905A:        SEC                       
CODE_00905B:        SBC DATA_008FFC,Y       
CODE_00905E:        STA $06                   
CODE_009060:        BCC CODE_00906D           
CODE_009062:        LDA $06                   
CODE_009064:        STA $02                   
CODE_009066:        SEP #$20                  ; Accum (8 bit) 
CODE_009068:        LDA !RAM_BAR+!STARS_OFFSET,X   
		INC A
		STA !RAM_BAR+!STARS_OFFSET,x          
CODE_00906B:         BRA CODE_009056           

CODE_00906D:        INX  
		INX                     
CODE_00906E:        INY                       
CODE_00906F:        INY                       
CODE_009070:        INY                       
CODE_009071:        INY                       
CODE_009072:        CPY #$18                
CODE_009074:        BNE CODE_009051           
CODE_009076:        SEP #$20                  ; Accum (8 bit) 
Return009078:       RTS      


ItemBox:
	PHB
	PHK
	PLB
	LDA !bar_no
	ASL
	TAY
	REP #$20
	LDA DMA_Pointers,y
	STA $06
	SEP #$20
	LDY #$07
	LDA ($06),y
	BEQ .ret
	LDY $0DC2
	BEQ .ret
	PLB
	JML $809095
.ret
	PLB
	JML $8090D0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;enable save prompt flag fix
org $04E635
autoclean JML SaveFlag
org $049903
autoclean JML SaveFlag2

freedata
SaveFlag:
	LDA $01
	PHA
	JSR Trans
	rep #$10
	ldx.b $00
	lda.l $7ed000,x		;load layer 1 tilemap, and thus current translevel number
	sep #$10
	TAX
	PLA
	STA $01

	LDA $1EA2,x
	AND #$10
	BEQ .orig
	JML $84E624
.orig
	LDA #$05
	STA $13D9
	JML $84E63A

SaveFlag2:
	LDX $0DD5
	BEQ +
	BMI +
	JML $84990A
+
	LDA $01
	PHA
	JSR Trans
	LDA $00
	STA $04
	LDA $01
	STA $05
	PLA
	STA $01
	JML $8498C5

Trans:
	ldy.w $0dd6		;get current player*4
	lda.w $1f17,y		;ow player X position low
	lsr #4
	sta.b $00
	lda.w $1f19,y		;ow player y position low
	and.b #$f0
	ora.b $00
	sta.b $00
	lda.w $1f1A,y		;ow player y position high
	asl
	ora.w $1f18,y		;ow player x position high
	ldy.w $0db3		;get current player
	ldx.w $1f11,y		;get current map
	beq +
	clc : adc.b #$04		;if on submap, add $0400
+
	sta.b $01
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;booforducking
org $02FEAB
autoclean JML boofix

freespace noram
boofix:
BEQ +
LDY $73
BNE +
LDA #$0020
+
JML $82FEB0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;bonus star -> coin
org $05CF15
INC $13CC
BRA +
org $05CF1E
+

org $05CD51
db $2E,$3C

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;interaction_fast

!freeram = $13E6
; Hijacks
org $01808F
autoclean JML SpriteLoopStart

org $0180BE
autoclean JML SpriteLoopEnd

freecode
SpriteLoopStart:
		LDA $85
		PHA
		LDA !freeram
		BEQ +
		LDA #$01
		STA $85
	+

	LDA $1403
	BNE +

	LDA $190E
	AND #$40
	BEQ .ret
	LDA $5B
	PHA
	AND #$7F
	STA $5B
	LDA $190E
	PHA
	CMP #$C0
	BNE +
	STZ $190E
	BRA +
.ret
	LDA $190E
	PHA
+
	; original code
	LDA $148F
	STA $1470
	JML $818095

SpriteLoopEnd:

	LDA $1403
	BNE .ret

	PLA
	STA $190E

	AND #$40
	BEQ .ret
	PLA
	STA $5B
.ret
		PLA
		STA $85
	; original code
	LDA $18DF
	BNE +
	JML $8180C3
+
	JML $8180C9


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;extradisco
	org $02a9d2
		autoclean jml DiscoMain
	
	freecode
	DiscoMain:
		phy
		ldy.b $03
		lda.b #$04
		sta.w $1fe2,x
		lda.w $14c8,x
		cmp.b #$09
		bne DiscoReturn
		lda.b [$ce],y
		and.b #$04
		beq DiscoReturn
		lda.b #$30
		sta.w $166e,x
		lda.b $5b
		lsr a
		bcc DiscoHorz
		lda.b [$ce],y
		and.b #$01
		sta.w $14e0,x
		bra DiscoVert
	DiscoHorz:
		lda.b [$ce],y
		and.b #$01
		sta.w $14d4,x
	DiscoVert:
		lda.b #$01
		sta.w $187b,x
		inc.w $14c8,x
	DiscoReturn:
		ply
		jml $02a9d7


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;extra message
!infobox_ram = $7FA11D

; hijack the sprite
org $038D89
autoclean JML InfoBox

; hijack the part of message box routine
org $05B194
autoclean JML Message

freecode
InfoBox:
	LSR #4
	STA !infobox_ram
	JML $838D8D

Message:
	BNE +
	TXA
	BEQ ++
	JML $85B199
+
	JML $85B250
++
	LDA $1426
	CMP #$03	; yoshi thank you msg
	BEQ .orig
	REP #$30
	LDA $010B
-
	ASL
	TAX
	LDA.l .table+2,x
	SEC
	SBC.l .table,x
	STA $4204
	SEP #$20
	LDA #$90
	STA $4206
	NOP #8
	REP #$20
	LDA $4214
	BNE .extra

	LDA $13BF
	CMP #$0060
	BCC +
	AND #$001F
	CLC
	ADC #$01E0
	BRA -		; should exist message in 1E0-1FF
+
	SEP #$30
.orig
	JML $85B1A3
.extra
	; start of extramsg
	SEP #$20
	STA $00
	LDA !infobox_ram
	STA $4204
	STZ $4205
	LDA $00
	STA $4206
	NOP #8
	LDA $4216
	STA $4202
	LDA #$90
	STA $4203
	NOP #4
	REP #$20
	LDA $4216
	CLC
	ADC.l .table,x
	STA $00
	SEP #$20

	PHB
	LDA #$7F
	PHA
	PLB
	REP #$30
	LDY $837B
	LDX #$000E
	STZ $02
--
	LDA.l $03BC7F,x	; or $05A580
	STA $837D,y
	LDA #$2300
	STA $837F,y
	PHX
	SEP #$20
	LDA #$12
	STA $02
	LDX $00
-
	LDA #$1F
	BIT $03
	BMI +
	LDA.l MessageData,x
	INX
	CMP #$FE
	BNE +
	STA $03
	LDA #$1F
+
	STA $8381,y
	LDA #$39
	STA $8382,y
	INY
	INY
	DEC $02
	BNE -
	STX $00
	REP #$20
	INY
	INY
	INY
	INY
	PLX
	DEX
	DEX
	BPL --
	LDA #$00FF
	STA $837D,y
	STY $837B

	PLB
	STZ $22
	STZ $24
	SEP #$30
	LDA #$01
	STA $13D5
	JML $85B250

.table
	dw MessageData_extra_msg_0-MessageData
	dw MessageData_extra_msg_1-MessageData
	dw MessageData_extra_msg_2-MessageData
	dw MessageData_extra_msg_3-MessageData
	dw MessageData_extra_msg_4-MessageData
	dw MessageData_extra_msg_5-MessageData
	dw MessageData_extra_msg_6-MessageData
	dw MessageData_extra_msg_7-MessageData
	dw MessageData_extra_msg_8-MessageData
	dw MessageData_extra_msg_9-MessageData
	dw MessageData_extra_msg_A-MessageData
	dw MessageData_extra_msg_B-MessageData
	dw MessageData_extra_msg_C-MessageData
	dw MessageData_extra_msg_D-MessageData
	dw MessageData_extra_msg_E-MessageData
	dw MessageData_extra_msg_F-MessageData
	dw MessageData_extra_msg_10-MessageData
	dw MessageData_extra_msg_11-MessageData
	dw MessageData_extra_msg_12-MessageData
	dw MessageData_extra_msg_13-MessageData
	dw MessageData_extra_msg_14-MessageData
	dw MessageData_extra_msg_15-MessageData
	dw MessageData_extra_msg_16-MessageData
	dw MessageData_extra_msg_17-MessageData
	dw MessageData_extra_msg_18-MessageData
	dw MessageData_extra_msg_19-MessageData
	dw MessageData_extra_msg_1A-MessageData
	dw MessageData_extra_msg_1B-MessageData
	dw MessageData_extra_msg_1C-MessageData
	dw MessageData_extra_msg_1D-MessageData
	dw MessageData_extra_msg_1E-MessageData
	dw MessageData_extra_msg_1F-MessageData
	dw MessageData_extra_msg_20-MessageData
	dw MessageData_extra_msg_21-MessageData
	dw MessageData_extra_msg_22-MessageData
	dw MessageData_extra_msg_23-MessageData
	dw MessageData_extra_msg_24-MessageData
	dw MessageData_extra_msg_25-MessageData
	dw MessageData_extra_msg_26-MessageData
	dw MessageData_extra_msg_27-MessageData
	dw MessageData_extra_msg_28-MessageData
	dw MessageData_extra_msg_29-MessageData
	dw MessageData_extra_msg_2A-MessageData
	dw MessageData_extra_msg_2B-MessageData
	dw MessageData_extra_msg_2C-MessageData
	dw MessageData_extra_msg_2D-MessageData
	dw MessageData_extra_msg_2E-MessageData
	dw MessageData_extra_msg_2F-MessageData
	dw MessageData_extra_msg_30-MessageData
	dw MessageData_extra_msg_31-MessageData
	dw MessageData_extra_msg_32-MessageData
	dw MessageData_extra_msg_33-MessageData
	dw MessageData_extra_msg_34-MessageData
	dw MessageData_extra_msg_35-MessageData
	dw MessageData_extra_msg_36-MessageData
	dw MessageData_extra_msg_37-MessageData
	dw MessageData_extra_msg_38-MessageData
	dw MessageData_extra_msg_39-MessageData
	dw MessageData_extra_msg_3A-MessageData
	dw MessageData_extra_msg_3B-MessageData
	dw MessageData_extra_msg_3C-MessageData
	dw MessageData_extra_msg_3D-MessageData
	dw MessageData_extra_msg_3E-MessageData
	dw MessageData_extra_msg_3F-MessageData
	dw MessageData_extra_msg_40-MessageData
	dw MessageData_extra_msg_41-MessageData
	dw MessageData_extra_msg_42-MessageData
	dw MessageData_extra_msg_43-MessageData
	dw MessageData_extra_msg_44-MessageData
	dw MessageData_extra_msg_45-MessageData
	dw MessageData_extra_msg_46-MessageData
	dw MessageData_extra_msg_47-MessageData
	dw MessageData_extra_msg_48-MessageData
	dw MessageData_extra_msg_49-MessageData
	dw MessageData_extra_msg_4A-MessageData
	dw MessageData_extra_msg_4B-MessageData
	dw MessageData_extra_msg_4C-MessageData
	dw MessageData_extra_msg_4D-MessageData
	dw MessageData_extra_msg_4E-MessageData
	dw MessageData_extra_msg_4F-MessageData
	dw MessageData_extra_msg_50-MessageData
	dw MessageData_extra_msg_51-MessageData
	dw MessageData_extra_msg_52-MessageData
	dw MessageData_extra_msg_53-MessageData
	dw MessageData_extra_msg_54-MessageData
	dw MessageData_extra_msg_55-MessageData
	dw MessageData_extra_msg_56-MessageData
	dw MessageData_extra_msg_57-MessageData
	dw MessageData_extra_msg_58-MessageData
	dw MessageData_extra_msg_59-MessageData
	dw MessageData_extra_msg_5A-MessageData
	dw MessageData_extra_msg_5B-MessageData
	dw MessageData_extra_msg_5C-MessageData
	dw MessageData_extra_msg_5D-MessageData
	dw MessageData_extra_msg_5E-MessageData
	dw MessageData_extra_msg_5F-MessageData
	dw MessageData_extra_msg_60-MessageData
	dw MessageData_extra_msg_61-MessageData
	dw MessageData_extra_msg_62-MessageData
	dw MessageData_extra_msg_63-MessageData
	dw MessageData_extra_msg_64-MessageData
	dw MessageData_extra_msg_65-MessageData
	dw MessageData_extra_msg_66-MessageData
	dw MessageData_extra_msg_67-MessageData
	dw MessageData_extra_msg_68-MessageData
	dw MessageData_extra_msg_69-MessageData
	dw MessageData_extra_msg_6A-MessageData
	dw MessageData_extra_msg_6B-MessageData
	dw MessageData_extra_msg_6C-MessageData
	dw MessageData_extra_msg_6D-MessageData
	dw MessageData_extra_msg_6E-MessageData
	dw MessageData_extra_msg_6F-MessageData
	dw MessageData_extra_msg_70-MessageData
	dw MessageData_extra_msg_71-MessageData
	dw MessageData_extra_msg_72-MessageData
	dw MessageData_extra_msg_73-MessageData
	dw MessageData_extra_msg_74-MessageData
	dw MessageData_extra_msg_75-MessageData
	dw MessageData_extra_msg_76-MessageData
	dw MessageData_extra_msg_77-MessageData
	dw MessageData_extra_msg_78-MessageData
	dw MessageData_extra_msg_79-MessageData
	dw MessageData_extra_msg_7A-MessageData
	dw MessageData_extra_msg_7B-MessageData
	dw MessageData_extra_msg_7C-MessageData
	dw MessageData_extra_msg_7D-MessageData
	dw MessageData_extra_msg_7E-MessageData
	dw MessageData_extra_msg_7F-MessageData
	dw MessageData_extra_msg_80-MessageData
	dw MessageData_extra_msg_81-MessageData
	dw MessageData_extra_msg_82-MessageData
	dw MessageData_extra_msg_83-MessageData
	dw MessageData_extra_msg_84-MessageData
	dw MessageData_extra_msg_85-MessageData
	dw MessageData_extra_msg_86-MessageData
	dw MessageData_extra_msg_87-MessageData
	dw MessageData_extra_msg_88-MessageData
	dw MessageData_extra_msg_89-MessageData
	dw MessageData_extra_msg_8A-MessageData
	dw MessageData_extra_msg_8B-MessageData
	dw MessageData_extra_msg_8C-MessageData
	dw MessageData_extra_msg_8D-MessageData
	dw MessageData_extra_msg_8E-MessageData
	dw MessageData_extra_msg_8F-MessageData
	dw MessageData_extra_msg_90-MessageData
	dw MessageData_extra_msg_91-MessageData
	dw MessageData_extra_msg_92-MessageData
	dw MessageData_extra_msg_93-MessageData
	dw MessageData_extra_msg_94-MessageData
	dw MessageData_extra_msg_95-MessageData
	dw MessageData_extra_msg_96-MessageData
	dw MessageData_extra_msg_97-MessageData
	dw MessageData_extra_msg_98-MessageData
	dw MessageData_extra_msg_99-MessageData
	dw MessageData_extra_msg_9A-MessageData
	dw MessageData_extra_msg_9B-MessageData
	dw MessageData_extra_msg_9C-MessageData
	dw MessageData_extra_msg_9D-MessageData
	dw MessageData_extra_msg_9E-MessageData
	dw MessageData_extra_msg_9F-MessageData
	dw MessageData_extra_msg_A0-MessageData
	dw MessageData_extra_msg_A1-MessageData
	dw MessageData_extra_msg_A2-MessageData
	dw MessageData_extra_msg_A3-MessageData
	dw MessageData_extra_msg_A4-MessageData
	dw MessageData_extra_msg_A5-MessageData
	dw MessageData_extra_msg_A6-MessageData
	dw MessageData_extra_msg_A7-MessageData
	dw MessageData_extra_msg_A8-MessageData
	dw MessageData_extra_msg_A9-MessageData
	dw MessageData_extra_msg_AA-MessageData
	dw MessageData_extra_msg_AB-MessageData
	dw MessageData_extra_msg_AC-MessageData
	dw MessageData_extra_msg_AD-MessageData
	dw MessageData_extra_msg_AE-MessageData
	dw MessageData_extra_msg_AF-MessageData
	dw MessageData_extra_msg_B0-MessageData
	dw MessageData_extra_msg_B1-MessageData
	dw MessageData_extra_msg_B2-MessageData
	dw MessageData_extra_msg_B3-MessageData
	dw MessageData_extra_msg_B4-MessageData
	dw MessageData_extra_msg_B5-MessageData
	dw MessageData_extra_msg_B6-MessageData
	dw MessageData_extra_msg_B7-MessageData
	dw MessageData_extra_msg_B8-MessageData
	dw MessageData_extra_msg_B9-MessageData
	dw MessageData_extra_msg_BA-MessageData
	dw MessageData_extra_msg_BB-MessageData
	dw MessageData_extra_msg_BC-MessageData
	dw MessageData_extra_msg_BD-MessageData
	dw MessageData_extra_msg_BE-MessageData
	dw MessageData_extra_msg_BF-MessageData
	dw MessageData_extra_msg_C0-MessageData
	dw MessageData_extra_msg_C1-MessageData
	dw MessageData_extra_msg_C2-MessageData
	dw MessageData_extra_msg_C3-MessageData
	dw MessageData_extra_msg_C4-MessageData
	dw MessageData_extra_msg_C5-MessageData
	dw MessageData_extra_msg_C6-MessageData
	dw MessageData_extra_msg_C7-MessageData
	dw MessageData_extra_msg_C8-MessageData
	dw MessageData_extra_msg_C9-MessageData
	dw MessageData_extra_msg_CA-MessageData
	dw MessageData_extra_msg_CB-MessageData
	dw MessageData_extra_msg_CC-MessageData
	dw MessageData_extra_msg_CD-MessageData
	dw MessageData_extra_msg_CE-MessageData
	dw MessageData_extra_msg_CF-MessageData
	dw MessageData_extra_msg_D0-MessageData
	dw MessageData_extra_msg_D1-MessageData
	dw MessageData_extra_msg_D2-MessageData
	dw MessageData_extra_msg_D3-MessageData
	dw MessageData_extra_msg_D4-MessageData
	dw MessageData_extra_msg_D5-MessageData
	dw MessageData_extra_msg_D6-MessageData
	dw MessageData_extra_msg_D7-MessageData
	dw MessageData_extra_msg_D8-MessageData
	dw MessageData_extra_msg_D9-MessageData
	dw MessageData_extra_msg_DA-MessageData
	dw MessageData_extra_msg_DB-MessageData
	dw MessageData_extra_msg_DC-MessageData
	dw MessageData_extra_msg_DD-MessageData
	dw MessageData_extra_msg_DE-MessageData
	dw MessageData_extra_msg_DF-MessageData
	dw MessageData_extra_msg_E0-MessageData
	dw MessageData_extra_msg_E1-MessageData
	dw MessageData_extra_msg_E2-MessageData
	dw MessageData_extra_msg_E3-MessageData
	dw MessageData_extra_msg_E4-MessageData
	dw MessageData_extra_msg_E5-MessageData
	dw MessageData_extra_msg_E6-MessageData
	dw MessageData_extra_msg_E7-MessageData
	dw MessageData_extra_msg_E8-MessageData
	dw MessageData_extra_msg_E9-MessageData
	dw MessageData_extra_msg_EA-MessageData
	dw MessageData_extra_msg_EB-MessageData
	dw MessageData_extra_msg_EC-MessageData
	dw MessageData_extra_msg_ED-MessageData
	dw MessageData_extra_msg_EE-MessageData
	dw MessageData_extra_msg_EF-MessageData
	dw MessageData_extra_msg_F0-MessageData
	dw MessageData_extra_msg_F1-MessageData
	dw MessageData_extra_msg_F2-MessageData
	dw MessageData_extra_msg_F3-MessageData
	dw MessageData_extra_msg_F4-MessageData
	dw MessageData_extra_msg_F5-MessageData
	dw MessageData_extra_msg_F6-MessageData
	dw MessageData_extra_msg_F7-MessageData
	dw MessageData_extra_msg_F8-MessageData
	dw MessageData_extra_msg_F9-MessageData
	dw MessageData_extra_msg_FA-MessageData
	dw MessageData_extra_msg_FB-MessageData
	dw MessageData_extra_msg_FC-MessageData
	dw MessageData_extra_msg_FD-MessageData
	dw MessageData_extra_msg_FE-MessageData
	dw MessageData_extra_msg_FF-MessageData
	dw MessageData_extra_msg_100-MessageData
	dw MessageData_extra_msg_101-MessageData
	dw MessageData_extra_msg_102-MessageData
	dw MessageData_extra_msg_103-MessageData
	dw MessageData_extra_msg_104-MessageData
	dw MessageData_extra_msg_105-MessageData
	dw MessageData_extra_msg_106-MessageData
	dw MessageData_extra_msg_107-MessageData
	dw MessageData_extra_msg_108-MessageData
	dw MessageData_extra_msg_109-MessageData
	dw MessageData_extra_msg_10A-MessageData
	dw MessageData_extra_msg_10B-MessageData
	dw MessageData_extra_msg_10C-MessageData
	dw MessageData_extra_msg_10D-MessageData
	dw MessageData_extra_msg_10E-MessageData
	dw MessageData_extra_msg_10F-MessageData
	dw MessageData_extra_msg_110-MessageData
	dw MessageData_extra_msg_111-MessageData
	dw MessageData_extra_msg_112-MessageData
	dw MessageData_extra_msg_113-MessageData
	dw MessageData_extra_msg_114-MessageData
	dw MessageData_extra_msg_115-MessageData
	dw MessageData_extra_msg_116-MessageData
	dw MessageData_extra_msg_117-MessageData
	dw MessageData_extra_msg_118-MessageData
	dw MessageData_extra_msg_119-MessageData
	dw MessageData_extra_msg_11A-MessageData
	dw MessageData_extra_msg_11B-MessageData
	dw MessageData_extra_msg_11C-MessageData
	dw MessageData_extra_msg_11D-MessageData
	dw MessageData_extra_msg_11E-MessageData
	dw MessageData_extra_msg_11F-MessageData
	dw MessageData_extra_msg_120-MessageData
	dw MessageData_extra_msg_121-MessageData
	dw MessageData_extra_msg_122-MessageData
	dw MessageData_extra_msg_123-MessageData
	dw MessageData_extra_msg_124-MessageData
	dw MessageData_extra_msg_125-MessageData
	dw MessageData_extra_msg_126-MessageData
	dw MessageData_extra_msg_127-MessageData
	dw MessageData_extra_msg_128-MessageData
	dw MessageData_extra_msg_129-MessageData
	dw MessageData_extra_msg_12A-MessageData
	dw MessageData_extra_msg_12B-MessageData
	dw MessageData_extra_msg_12C-MessageData
	dw MessageData_extra_msg_12D-MessageData
	dw MessageData_extra_msg_12E-MessageData
	dw MessageData_extra_msg_12F-MessageData
	dw MessageData_extra_msg_130-MessageData
	dw MessageData_extra_msg_131-MessageData
	dw MessageData_extra_msg_132-MessageData
	dw MessageData_extra_msg_133-MessageData
	dw MessageData_extra_msg_134-MessageData
	dw MessageData_extra_msg_135-MessageData
	dw MessageData_extra_msg_136-MessageData
	dw MessageData_extra_msg_137-MessageData
	dw MessageData_extra_msg_138-MessageData
	dw MessageData_extra_msg_139-MessageData
	dw MessageData_extra_msg_13A-MessageData
	dw MessageData_extra_msg_13B-MessageData
	dw MessageData_extra_msg_13C-MessageData
	dw MessageData_extra_msg_13D-MessageData
	dw MessageData_extra_msg_13E-MessageData
	dw MessageData_extra_msg_13F-MessageData
	dw MessageData_extra_msg_140-MessageData
	dw MessageData_extra_msg_141-MessageData
	dw MessageData_extra_msg_142-MessageData
	dw MessageData_extra_msg_143-MessageData
	dw MessageData_extra_msg_144-MessageData
	dw MessageData_extra_msg_145-MessageData
	dw MessageData_extra_msg_146-MessageData
	dw MessageData_extra_msg_147-MessageData
	dw MessageData_extra_msg_148-MessageData
	dw MessageData_extra_msg_149-MessageData
	dw MessageData_extra_msg_14A-MessageData
	dw MessageData_extra_msg_14B-MessageData
	dw MessageData_extra_msg_14C-MessageData
	dw MessageData_extra_msg_14D-MessageData
	dw MessageData_extra_msg_14E-MessageData
	dw MessageData_extra_msg_14F-MessageData
	dw MessageData_extra_msg_150-MessageData
	dw MessageData_extra_msg_151-MessageData
	dw MessageData_extra_msg_152-MessageData
	dw MessageData_extra_msg_153-MessageData
	dw MessageData_extra_msg_154-MessageData
	dw MessageData_extra_msg_155-MessageData
	dw MessageData_extra_msg_156-MessageData
	dw MessageData_extra_msg_157-MessageData
	dw MessageData_extra_msg_158-MessageData
	dw MessageData_extra_msg_159-MessageData
	dw MessageData_extra_msg_15A-MessageData
	dw MessageData_extra_msg_15B-MessageData
	dw MessageData_extra_msg_15C-MessageData
	dw MessageData_extra_msg_15D-MessageData
	dw MessageData_extra_msg_15E-MessageData
	dw MessageData_extra_msg_15F-MessageData
	dw MessageData_extra_msg_160-MessageData
	dw MessageData_extra_msg_161-MessageData
	dw MessageData_extra_msg_162-MessageData
	dw MessageData_extra_msg_163-MessageData
	dw MessageData_extra_msg_164-MessageData
	dw MessageData_extra_msg_165-MessageData
	dw MessageData_extra_msg_166-MessageData
	dw MessageData_extra_msg_167-MessageData
	dw MessageData_extra_msg_168-MessageData
	dw MessageData_extra_msg_169-MessageData
	dw MessageData_extra_msg_16A-MessageData
	dw MessageData_extra_msg_16B-MessageData
	dw MessageData_extra_msg_16C-MessageData
	dw MessageData_extra_msg_16D-MessageData
	dw MessageData_extra_msg_16E-MessageData
	dw MessageData_extra_msg_16F-MessageData
	dw MessageData_extra_msg_170-MessageData
	dw MessageData_extra_msg_171-MessageData
	dw MessageData_extra_msg_172-MessageData
	dw MessageData_extra_msg_173-MessageData
	dw MessageData_extra_msg_174-MessageData
	dw MessageData_extra_msg_175-MessageData
	dw MessageData_extra_msg_176-MessageData
	dw MessageData_extra_msg_177-MessageData
	dw MessageData_extra_msg_178-MessageData
	dw MessageData_extra_msg_179-MessageData
	dw MessageData_extra_msg_17A-MessageData
	dw MessageData_extra_msg_17B-MessageData
	dw MessageData_extra_msg_17C-MessageData
	dw MessageData_extra_msg_17D-MessageData
	dw MessageData_extra_msg_17E-MessageData
	dw MessageData_extra_msg_17F-MessageData
	dw MessageData_extra_msg_180-MessageData
	dw MessageData_extra_msg_181-MessageData
	dw MessageData_extra_msg_182-MessageData
	dw MessageData_extra_msg_183-MessageData
	dw MessageData_extra_msg_184-MessageData
	dw MessageData_extra_msg_185-MessageData
	dw MessageData_extra_msg_186-MessageData
	dw MessageData_extra_msg_187-MessageData
	dw MessageData_extra_msg_188-MessageData
	dw MessageData_extra_msg_189-MessageData
	dw MessageData_extra_msg_18A-MessageData
	dw MessageData_extra_msg_18B-MessageData
	dw MessageData_extra_msg_18C-MessageData
	dw MessageData_extra_msg_18D-MessageData
	dw MessageData_extra_msg_18E-MessageData
	dw MessageData_extra_msg_18F-MessageData
	dw MessageData_extra_msg_190-MessageData
	dw MessageData_extra_msg_191-MessageData
	dw MessageData_extra_msg_192-MessageData
	dw MessageData_extra_msg_193-MessageData
	dw MessageData_extra_msg_194-MessageData
	dw MessageData_extra_msg_195-MessageData
	dw MessageData_extra_msg_196-MessageData
	dw MessageData_extra_msg_197-MessageData
	dw MessageData_extra_msg_198-MessageData
	dw MessageData_extra_msg_199-MessageData
	dw MessageData_extra_msg_19A-MessageData
	dw MessageData_extra_msg_19B-MessageData
	dw MessageData_extra_msg_19C-MessageData
	dw MessageData_extra_msg_19D-MessageData
	dw MessageData_extra_msg_19E-MessageData
	dw MessageData_extra_msg_19F-MessageData
	dw MessageData_extra_msg_1A0-MessageData
	dw MessageData_extra_msg_1A1-MessageData
	dw MessageData_extra_msg_1A2-MessageData
	dw MessageData_extra_msg_1A3-MessageData
	dw MessageData_extra_msg_1A4-MessageData
	dw MessageData_extra_msg_1A5-MessageData
	dw MessageData_extra_msg_1A6-MessageData
	dw MessageData_extra_msg_1A7-MessageData
	dw MessageData_extra_msg_1A8-MessageData
	dw MessageData_extra_msg_1A9-MessageData
	dw MessageData_extra_msg_1AA-MessageData
	dw MessageData_extra_msg_1AB-MessageData
	dw MessageData_extra_msg_1AC-MessageData
	dw MessageData_extra_msg_1AD-MessageData
	dw MessageData_extra_msg_1AE-MessageData
	dw MessageData_extra_msg_1AF-MessageData
	dw MessageData_extra_msg_1B0-MessageData
	dw MessageData_extra_msg_1B1-MessageData
	dw MessageData_extra_msg_1B2-MessageData
	dw MessageData_extra_msg_1B3-MessageData
	dw MessageData_extra_msg_1B4-MessageData
	dw MessageData_extra_msg_1B5-MessageData
	dw MessageData_extra_msg_1B6-MessageData
	dw MessageData_extra_msg_1B7-MessageData
	dw MessageData_extra_msg_1B8-MessageData
	dw MessageData_extra_msg_1B9-MessageData
	dw MessageData_extra_msg_1BA-MessageData
	dw MessageData_extra_msg_1BB-MessageData
	dw MessageData_extra_msg_1BC-MessageData
	dw MessageData_extra_msg_1BD-MessageData
	dw MessageData_extra_msg_1BE-MessageData
	dw MessageData_extra_msg_1BF-MessageData
	dw MessageData_extra_msg_1C0-MessageData
	dw MessageData_extra_msg_1C1-MessageData
	dw MessageData_extra_msg_1C2-MessageData
	dw MessageData_extra_msg_1C3-MessageData
	dw MessageData_extra_msg_1C4-MessageData
	dw MessageData_extra_msg_1C5-MessageData
	dw MessageData_extra_msg_1C6-MessageData
	dw MessageData_extra_msg_1C7-MessageData
	dw MessageData_extra_msg_1C8-MessageData
	dw MessageData_extra_msg_1C9-MessageData
	dw MessageData_extra_msg_1CA-MessageData
	dw MessageData_extra_msg_1CB-MessageData
	dw MessageData_extra_msg_1CC-MessageData
	dw MessageData_extra_msg_1CD-MessageData
	dw MessageData_extra_msg_1CE-MessageData
	dw MessageData_extra_msg_1CF-MessageData
	dw MessageData_extra_msg_1D0-MessageData
	dw MessageData_extra_msg_1D1-MessageData
	dw MessageData_extra_msg_1D2-MessageData
	dw MessageData_extra_msg_1D3-MessageData
	dw MessageData_extra_msg_1D4-MessageData
	dw MessageData_extra_msg_1D5-MessageData
	dw MessageData_extra_msg_1D6-MessageData
	dw MessageData_extra_msg_1D7-MessageData
	dw MessageData_extra_msg_1D8-MessageData
	dw MessageData_extra_msg_1D9-MessageData
	dw MessageData_extra_msg_1DA-MessageData
	dw MessageData_extra_msg_1DB-MessageData
	dw MessageData_extra_msg_1DC-MessageData
	dw MessageData_extra_msg_1DD-MessageData
	dw MessageData_extra_msg_1DE-MessageData
	dw MessageData_extra_msg_1DF-MessageData
	dw MessageData_extra_msg_1E0-MessageData
	dw MessageData_extra_msg_1E1-MessageData
	dw MessageData_extra_msg_1E2-MessageData
	dw MessageData_extra_msg_1E3-MessageData
	dw MessageData_extra_msg_1E4-MessageData
	dw MessageData_extra_msg_1E5-MessageData
	dw MessageData_extra_msg_1E6-MessageData
	dw MessageData_extra_msg_1E7-MessageData
	dw MessageData_extra_msg_1E8-MessageData
	dw MessageData_extra_msg_1E9-MessageData
	dw MessageData_extra_msg_1EA-MessageData
	dw MessageData_extra_msg_1EB-MessageData
	dw MessageData_extra_msg_1EC-MessageData
	dw MessageData_extra_msg_1ED-MessageData
	dw MessageData_extra_msg_1EE-MessageData
	dw MessageData_extra_msg_1EF-MessageData
	dw MessageData_extra_msg_1F0-MessageData
	dw MessageData_extra_msg_1F1-MessageData
	dw MessageData_extra_msg_1F2-MessageData
	dw MessageData_extra_msg_1F3-MessageData
	dw MessageData_extra_msg_1F4-MessageData
	dw MessageData_extra_msg_1F5-MessageData
	dw MessageData_extra_msg_1F6-MessageData
	dw MessageData_extra_msg_1F7-MessageData
	dw MessageData_extra_msg_1F8-MessageData
	dw MessageData_extra_msg_1F9-MessageData
	dw MessageData_extra_msg_1FA-MessageData
	dw MessageData_extra_msg_1FB-MessageData
	dw MessageData_extra_msg_1FC-MessageData
	dw MessageData_extra_msg_1FD-MessageData
	dw MessageData_extra_msg_1FE-MessageData
	dw MessageData_extra_msg_1FF-MessageData
	dw MessageData_end-MessageData


MessageData:
	incsrc ExtraMsgData.asm
.end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;coin sfx (floating coins only)
	org $00F367
		autoclean JSL IncreaseCoin
	
	freecode
	IncreaseCoin:
		INC $13CC

		PHX
		LDX #$0B
	-
		LDA $14C8,x
		CMP #$08
		BCC +
		LDA $9E,x
		CMP #$64	; from rope mechanism
		BCC +
		CMP #$68	; to chainsaw/grinder
		BCC ++
		CMP #$B4	; non line guided grinder
		BEQ ++
		CMP #$B1	; creating/eating block
		BNE +
		LDA $1909
		BPL ++		; activated
	+
		DEX
		BPL -

		LDA $75
		BNE ++		; in water
		;LDA $13BF	; translevelnum
		;BEQ ++

		;REP #$20
		;LDA $010B	; sublevel specific
		;SEP #$20
		LDA #$2C
		STA $1DF9
		BRA +++
	+
		;SEP #$20
	++
		LDA #$01
		STA $1DFC
	+++
		LDA $0DC0
		BEQ +
		DEC $0DC0
	+
		PLX
		RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;extra translevel
;handles $13BF, $1DEA, $1EA2, $1F2F, $1F3C, and $1FEE
	org $00A261
		autoclean JML Check1EA2_1	;beat
	org $00F2B8
		autoclean JML Set1F3C
	org $00F322
		autoclean JML Set1FEE
	;org $00F351	; already done by dc counter patch
		;autoclean JML Set1F2F
	;org $048E2E	; already done
		;db $80
	org $05D89B
		autoclean JML Set13BF
	org $05D9C9
		autoclean JML Set1DEA
	org $05D9D4
		autoclean JML Check1EA2_2	;midpt
	org $0DA59C
		autoclean JML Check1FEE
	org $0DA5A7
		autoclean JML Check1F3C
	org $0DA691
		autoclean JML Check1EA2_3	;midpt
	org $0DB2D7
		autoclean JML Check1F2F
	org $048F45
		autoclean JML Set1EA2_1		;midpt
	org $048F63
		autoclean JML Set1EA2_2		;beat
	org $049299
		autoclean JML Check1EA2_4	;udlr
	org $0496C0
		autoclean JML Set1EA2_3		;udlr
	org $049950
		autoclean JML Set1EA2_4		;udlr

	org $05D8BC
		autoclean JML SetDest
	org $05DAE1	; Next, we should disable the variability of level 24...
		db $80,$08,$EA,$EA,$EA,$EA,$EA,$EA,$EA,$EA

	org $05D8B7
		BRA +
		NOP #3;the levelnum patch goes here in many ROMs, just skip over it
	+

	org $05D8C0
		STA $010B
		ASL
		CLC
		ADC $0E
		TAY
		LDA.w $E000,Y
		STA $65
		LDA.w $E001,Y
		STA $66
		LDA.w $E600,Y
		STA $68
		LDA.w $E601,Y
		STA $69
		BRA +

	org $05D8E0
		+

freecode
Check1EA2_1:
	LDY $13BF
	CPY #$60
	BCC +
	PHX
	TYX
	LDA $7FA480-$60,x
	PLX
	CMP #$00
	BRA ++
+
	LDA $1EA2,y
++
	JML $80A267
	

Set1F3C:
	TYX
	CPX #$0C
	BCC +
	ORA $7FA4A4-$C,x
	STA $7FA4A4-$C,x
	BRA ++
+
	ORA $1F3C,x
	STA $1F3C,x
++
	JML $80F2BE


Set1FEE:
	TYX
	CPX #$0C
	BCC +
	ORA $7FA4A8-$C,x
	STA $7FA4A8-$C,x
	BRA ++
+
	ORA $1FEE,x
	STA $1FEE,x
++
	JML $80F328


Set13BF:
	LDA $7ED000,x
	STA $13BF
	LDA $0109
	CMP #$E9
	BEQ +
	LDA $7FC800,x
	BEQ +
	LDA $13BF
	AND #$1F
	CLC
	ADC #$60
	STA $13BF
+
	LDA $13BF
	JML $85D8AC

Set1DEA:
	LDY $13BF
	CPY #$0060
	BCC +
	PHX
	TYX
	LDA.l TransData_eventnum-$60,x
	PLX
	BRA ++
+
	LDA $D608,y
++
	JML $85D9CF

Check1EA2_2:
	LDX $13BF
	CPX #$60
	BCC +
	LDA $7FA480-$60,x
	JML $85D9DA
	BRA ++
+
	LDA $1EA2,x
++
	JML $85D9DA

Check1FEE:
	CPY #$0C
	BCC +
	PHX
	TYX
	LDA $7FA4A8-$C,x
	PLX
	BRA ++
+
	LDA $1FEE,y
++
	AND.l $0DA8A6,x
	JML $8DA5A3

Check1F3C:
	CPY #$0C
	BCC +
	PHX
	TYX
	LDA $7FA4A4-$C,x
	PLX
	BRA ++
+
	LDA $1F3C,y
++
	AND.l $0DA8A6,x
	JML $8DA5AE

Check1EA2_3:
	CPX #$60
	BCC +
	LDA $7FA480-$60,x
	BRA ++
+
	LDA $1EA2,x
++
	JML $8DA695

Check1F2F:
	CPY #$0C
	BCC +
	PHX
	TYX
	LDA $7FA4A0-$C,x
	PLX
	BRA ++
+
	LDA $1F2F,y
++
	AND.l $0DA8A6,x
	JML $8DB2DE
Set1EA2_1:
	LDA $7FC800,x
	AND #$00FF
	BEQ +
	LDA $7ED000,x
	AND #$001F
	TAX
	LDA $7FA480,x
	ORA #$0040
	STA $7FA480,x
	JML $848F56
+
	LDA $7ED000,x
	JML $848F49

Set1EA2_2:
	LDA $7FC800,x
	AND #$00FF
	BEQ +
	LDA $7ED000,x
	AND #$001F
	TAX
	LDA $7FA480,x
	ORA #$0080
	AND #$FFBF
	STA $7FA480,x
	JML $848F77
+
	LDA $7ED000,x
	JML $848F67
Check1EA2_4:
	LDA $7FC800,x
	AND #$00FF
	BEQ +
	LDA $7ED000,x
	AND #$001F
	TAX
	PLA
	AND.l $7FA480,x
	JML $8492A5
+
	LDA $7ED000,x
	JML $84929D

Set1EA2_3:
	LDA $7FC800,x
	AND #$00FF
	BEQ +
	LDA $7ED000,x
	AND #$001F
	TAX
	LDA $941E,y
	ORA.l $7FA480,x
	STA $7FA480,x
	JML $8496D1
+
	LDA $7ED000,x
	JML $8496C4

Set1EA2_4:
	LDA $7FC800,x
	AND #$00FF
	BEQ +
	LDA $7ED000,x
	AND #$001F
	TAX
	LDA $941E,y
	ORA.l $7FA480,x
	STA $7FA480,x
	JML $849961
+
	LDA $7ED000,x
	JML $849954



InitTransFlags:
	LDA #$00
	LDX #$03
-
	STA $7FA4A0,x
	STA $7FA4A4,x
	STA $7FA4A8,x
	DEX
	BPL -

	LDX #$1F
-
	LDA.l TransData_initflags,x
	STA $7FA480,x
	DEX
	BPL -
	RTL



SetDest:
	SEP #$30
	LDA $141A
	ORA $1B93
	BEQ +
	JMP .ret
+
	LDA $13BF
	CMP #$60
	BCC .normal
	CLC
	ADC #$80
	STA $0E
	LDA #$01
	STA $0F
	LDA $13BF
.normal
	;TODO: check multiple midpoint
.ret		; w/o considering midpt flag
	REP #$30
	LDA $0E
	JML $85D8C0


TransData:
	incsrc ExtraTransLVData.asm

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;initram

;titlescreen
org $0096B4
autoclean JML InitRam

freecode
InitRam:
	JSL InitTransFlags
;orig
	LDX #$07
	LDA #$FF
	JML $8096B8

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;powerup init
org $0091A6
autoclean JML PowerupInit

freecode
PowerupInit:
	LDA $141A
	BNE .orig	; not init
	LDA $00
	PHA

	JSR .get_powerup_filter_info

	LDA $00
	AND #$01	; cape filter
	BEQ +
	LDA $19
	CMP #$02
	BNE ++
	LDA #$01
	STA $19
++
	LDA $0DC2
	CMP #$04
	BNE +
	LDA #$01
	STA $0DC2
+

	LDA $00
	AND #$02	; fire filter
	BEQ +
	LDA $19
	CMP #$03
	BNE ++
	LDA #$01
	STA $19
++
	LDA $0DC2
	CMP #$02
	BNE +
	LDA #$01
	STA $0DC2
+

	LDA $00
	AND #$04	; mushroom filter
	BEQ +
	STZ $19
	STZ $0DC2
+

	PLA
	STA $00
.orig
	;orig
	LDA $141A
	BNE +
	JML $8091AB
+
	JML $8091B0

.get_powerup_filter_info
	REP #$30
	LDA $13BF
	AND #$00FF
	ASL
	ASL
	CLC
	ADC #$0003
	TAX
	SEP #$20
	STZ $00
	LDY #$0003
-
	LDA.l LevelInfo_infolist,x
	CMP #$02
	BNE +
	LDA #$04
	STA $00
	BRA +++
+
	CMP #$03
	BNE +
	LDA #$01
	TSB $00
	BRA ++
+
	CMP #$04
	BNE ++
	LDA #$02
	TSB $00
++
	DEX
	DEY
	BPL -
+++
	SEP #$10
	RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;entrance edit
!FreeRAM2 = $7ec120

	org $05da24
		autoclean jml CodeStart

	org $05daac
		autoclean jml CodeStart2

	org $00a692
		autoclean jml CodeStart3

	org $00c870
		autoclean jml CodeStart4

	freecode
	CodeStart:
		LDA #$00
		STA !FreeRAM2
		LDX $13BF
		LDA.l E_DATA,x
		BNE .Custom
		ldx.b #$04
		ldy.b #$04
		jml $85da28		;1..

	.Return
		jml $85dad7		;0...
	.Return1
		jml $85dad0

	.Custom
		ldy.b #$03
		ldx.b #$04
		lda.w $141a		;2..
		bne .Return
		lda.w $141d
		bne .Return
		lda.w $141f 
		bne .Return
		lda $13cf
		bne .Return1
		lda.b #$ab
		sta.l !FreeRAM2
		;jml $85da65
		lda.b #$60
		sta.b $96
		lda.b #$01
		sta.b $97
		lda.b #$30
		sta.b $94
		stz.b $95
		lda.b #$C0
		sta.b $1C
		sta.b $20
		stz.w $192a
		jml $85da8a
	
	CodeStart2:
		lda.l !FreeRAM2
		cmp.b #$ab
		beq .Custom2
		txa			;
		asl
		clc
		adc.b $00
		jml $85dab1

	.Custom2
		rep #$30
		lda.b $0e
		and.w #$01ff
		tax
		lda.l E_DATA,x
		and.w #$00ff
		sta.b $00
		asl
		clc
		adc.b $00
		tax
		sep #$20
		lda.l $85e000,x			;levelPtr1
		sta.b $65
		lda.l $85e001,x
		sta.b $66
		lda.l $85e002,x
		sta.b $67
		lda.l $85e600,x			;levelPtr2
		sta.b $68
		lda.l $85e601,x
		sta.b $69
		lda.l $85e602,x
		sta.b $6a
		rep #$20
		lda.b $00
		asl
		tax
		sep #$20
		lda.l $85ec00,x			;levelPtrS
		sta.b $ce
		lda.l $85ec01,x
		sta.b $cf
		ldx.b $00
		lda.l $8ef100,x
		sta.b $d0
		sep #$10
		ldy.b #$04
		lda.b [$65],y
		and.b #$0f
		sta.w $1931
		lda.l $85f200,x
		and.b #$c0
		clc
		asl
		rol
		rol
		sta.w $1be3
		stz.w $141d
		stz.w $141a
		stz.w $141f
		stz.w $13cf
		ldx.b #$05
		jml $85dad7			;$00A6C5

	CodeStart3:
		ldy.b #$01
		ldx.w $1931
		lda.l !FreeRAM2
		cmp.b #$ab
		beq .Custom3
		jml $80a697

	.Custom3
		stz.w $1497
		jml $80a6b6

	CodeStart4:
		stz.w $13e2		;A=7;
		ldx.w $1931
		lda.l !FreeRAM2
		cmp.b #$ab
		beq .Custom4
		lda.b #$07
		jml $80c876

	.Custom4
		jml $80c88d
			
	E_DATA:	
		incsrc NoYoshiData.asm

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;yoshi init fix
org $0096F4
autoclean JML NoYoshiIntroFix

freecode
NoYoshiIntroFix:
	JSL $85D796
	LDA $141A
	BNE .ret	; do nothing

	LDX $13BF
	LDA.l E_DATA,x
	BNE +		; custom no yoshi intro
	; vanilla case: only midpoint should be dealt
	LDA $141F
	BNE ++		; try 2ndary filter if disabled no yoshi intro
	LDX $1931
	CPX #$10
	BCS ++
	LDA.l $80A625,X
	LSR
	BEQ ++		; try 2ndary filter if GFX tile == normal, underground, etc.

+
	; already filtered by no yoshi intro
	; fix when $13CF != 0 (vanilla no yoshi intro + midpoint) || $1B9B != 0 (already set by custom yoshi intro)
	LDA $13CF
	ORA $1B9B
	BEQ .ret

	STZ $187A	; correcting pos
	LDA #$01
	STA $1B9B
	LDA #$03
	STA $1DFA
	STA $2141
.ret
	JML $8096F8
++
	; secondary filter
	JSR .get_yoshi_filter_info
	BCC .ret
	STZ $0DC1
	STZ $187A	; correcting pos
	LDA #$03
	STA $1DFA
	STA $2141
	BRA .ret

.get_yoshi_filter_info
	REP #$30
	LDA $13BF
	AND #$00FF
	ASL
	ASL
	CLC
	ADC #$0003
	TAX
	SEP #$20
	LDY #$0003
-
	LDA.l LevelInfo_infolist,x
	CMP #$01
	BNE +
	SEP #$10
	SEC
	RTS
+
	DEX
	DEY
	BPL -
++
	SEP #$10
	CLC
	RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;sprite extention recover
;clear the old code at freespace
if read1($0EF30F) == $42
	org $02A846
		autoclean JML ApplySpeed
	print "cleared old code which caused slowdown (this message should not appear more than once)"
endif

;recover
org $02A846
	db $C8,$C8,$E8,$80,$E3
org $02A9D7
	db $C8,$A6,$02,$E8,$4C,$2E,$A8
org $0EF30C
	db $FF,$FF,$FF,$FF

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;end of patch
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
